
! Remember the new and improved CLK2 Hz. Danger of 921600 ints per second...
!----------------------------------------------------------------------
!
!  NOKIA MOBIRA TMx-1 phones (some, at least, maybe)
!
!  Sun Mar 26 17:33:18 EEST 2000
!  Juha Nurmela, OH5NXO
!
!  Dirty hands on Juha's software
!  Vesa Tervo, 	 OH3NWQ
!  24-04-00 22:09
!
! Include standard disclaimer:
!
!	This software is given to and only to licensed ham radio 
!	operators for licensed radio amateur use. The software is given
! 	free of charge and as it is. No warranty is given in any way, 
!	nor is the suitability guaranteed for any purpose.
! 	The user of this program takes the full responsibility 
! 	of any direct or indirect consequencies caused by 
! 	using this program. Using the program indicates that the
! 	user accepts this statement.
! 	
!
!  uPD7810 CPU
!  MB1501 or MB87006 PLLs
!  MAS 7845 LFU
!  MAS 7825 NMT-modem
!  MC144111 6bit DAC
!  i8253 timer
!  what else
!  and other misc fluff
!
!  Usable (maybe) with companion handset HSN2 on MBUS
!
#define VERSION_1 "TMx1 1.7"
#define VERSION_2 "24.04.00"
!                  12345678ABCDEFGH
#define PROVERB   " I made   this  " /* v1.7  OH3NWQ */	
#define PROVERBe  "Tnks forthe fish" /* v1.6 */
#define PROVERBd  "Dave, mymind is " /* v1.5 */
#define PROVERBc  " *YAWN*  Zzz... " /* v1.4 */
#define PROVERBb  "Hasta lavvista !" /* v1.3 */
#define PROVERBa  "I'll be back !  " /* v1.2 */

!----------------------------------------------------------------------
! 18.3.2000
! v1.1
! Some CTCSS first cuts. Need an indicator ? The 'T' icon in LCD ?
! Center reading also.
! A/D warnings delayed.
! v1.2
! Duplex area used and xmit limits verified.
! Center display polished (still in no particular units, maybe 15Hz / tick)
! 1+ etc for freq bump.
! +/- on xmit bump power.
! v1.4
! Ugh.
! v1.5
! Touch adint ANM reload (rssi 99 errors, did not help ?).
! update_LFU_vol opened audio accidentally (keyclick x# errors).
! "dolby".
! v1.6
! relay 
! v1.7	 - OH3NWQ
!        - correction to the temperature measurements (now values go up when temp rises)
!        - charger menu
! 	 - battery voltage presented in hundreds of millivolts :)  
!
!----------------------------------------------------------------------
!
!
#define MBUSID "TMx1"

#define HS_ID "HSN2"

!----------------------------------------------------------------------
!
!  extended keycodes, 'X' '.', where
!  "XB" is extension bus (address and data follow)
!  "XC" is CW output      (text to send follow)
!  "XT" is ctcss output
!  "XD" is DTM........ hmmm.... yay.

!----------------------------------------------------------------------
!
!  portpins
!
!  PA
!
!  DATA and DTC are suitable for future expansion, now they are
!  left as unused inputs (there is 100kohm pulldown).
!  Very conveniently routed to the SIS module.
!  Remember the mode-trick for i2c later (flip between input and output,
!  and keep output latch at "0").
!  SCL/SDA not i2c although the names imply so.
!
SCL    = 0x01 ! output synth, D/A, LFU (and eeprom)
SDA    = 0x02 ! in/out synth, D/A, LFU
TSLG   = 0x04 ! output tx synth loopgain, "1" = slow, "0" = fast
DATA   = 0x08 ! in/out unused as of today.
LFUSTB = 0x10 ! output LFU strobe
CRM    = 0x20 ! output car radio mute
EXTA   = 0x40 ! output external alert
DTC    = 0x80 ! in/out unused as of today (+PTT in Pavel's software)
!
!  PB
!
!  EEOFF kept low, to get +5V, GND and /PTT into eeprom slot.
!
SD68   = 0x01 ! output 6/8V portable/car
TSEN   = 0x02 ! output tx synth enable pulse
RSEN   = 0x04 ! output rx synth enable pulse
PB3_NC = 0x08 ! no connection ? Available, how nice.
TXON   = 0x10 ! output tx supply "1"
TSON   = 0x20 ! output tx synth supply "1"
TAON   = 0x40 ! output tx audio supply "1"
EEOFF  = 0x80 ! output eeprom supply, "0" to supply +5V
!
!  PC
!
! PC0  = TXD output
! PC1  = RXD input
!
I2DA   = 0x04 ! in/out eeprom i2c data. Nominated as the /PTT. 10kohm pullup.
PAGE   = 0x08 ! output select eprom page at 0x8000, 1=flip from 0xC000
DADIS  = 0x10 ! output D/A enable, low active, thus DA DISABLE
! PC5  = CI input (aka netfree)
WDCLR  = 0x40 ! output watchdog clear, 2usec every 100msec says authotrity
PWROFF = 0x80 ! output power-off telephone
!
!  A/D inputs
!
! AN0 FSKL
! AN1 BCR  battery current
! AN2 BTMP battery temperature
! AN3 RSSI
! AN4 PFB  power feedback
! AN5 BATT +12V
! AN6 TEMP ambient temperature
! AN7 TIMEOUT (huh ? oh, yes. low in cold start)
!
!  chipselects
!
MODEM_DATA = 0xC000 ! MAS7825 modem    aka MENA
MODEM_CSR  = 0xC001

i8253_TMR0 = 0xC400 ! i8253 timer      aka TENA (confusing name)
i8253_TMR1 = 0xC401
i8253_TMR2 = 0xC402
i8253_CTRL = 0xC403

SISE  = 0xC800 ! Sis processor ? unwired chipselect to audio card
AMULE = 0xD400 ! 74259 AMU/LE (deviation latch) 3 LSbits for SMOD (D0 A0..2)

!----------------------------------------------------------------------
!
!  output latch on audio module, 74259, A2..0 and D0
!

!----------------------------------------------------------------------
!
!  Datatypes the menu supports
!
CFG_NOTYPE = 0
CFG_FREQ   = 1
CFG_FOFF   = 2
CFG_TAB    = 3
CFG_DIGIT  = 4
CFG_BYTE   = 5
CFG_MSEC   = 6
CFG_SEC    = 7
CFG_MINUTE = 8
CFG_STRING = 9
CFG_DYN    = 10
CFG_RST    = 11
CFG_EXEC   = 12       ! XXX no functionality yet
CFG_WORD   = 13
CFG_PERCENT= 14
CFG_HELP   = 15 
CFG_VOLT   = 16	      ! OH3NWQ

CFG_CONSTANT = 0x80 ! ORed into type

!----------------------------------------------------------------------
!
!  external RAM 8192 bytes
!  stack is located at the end of the ram.
!  Remember, workarea only 256 bytes (V.wa)
!  DO NOT CHANGE V from workarea !

	.data
	.org 0xE000
ram:
!----------------------------------------------------------------------
!
!  Configurable data. Keep each variable name and .rs on one row.
!
#define SIZE_FREQ 3 /* 24 bits for binary freq in kHz */
#define SIZE_MSEC 2 /* millisecs as a word */

!= start of nonvolatile area ==========================================
cfg_start_area:

	cfg_XXX_0:          .rs 4
	cfg_XXX_1:          .rs 4
	cfg_XXX_2:          .rs 4
	cfg_XXX_3:          .rs 4

	cfg_alertvol:       .rs 1
	cfg_autoscan_time:  .rs 1
	cfg_callfreq:       .rs SIZE_FREQ
	cfg_ccir_idx:       .rs 1
	cfg_chan_step:      .rs 1 ! table of 25, 20, 12.5 or 10
	cfg_dtmf_idx:       .rs 1
	cfg_duplex_dir:     .rs 1
	cfg_duplex_off:     .rs SIZE_FREQ
	cfg_if_dir:         .rs 1 ! table of above, below
	cfg_if_freq:        .rs SIZE_FREQ
	cfg_keyclick:       .rs 1
	cfg_pin_code:       .rs 8
	cfg_pin_type:       .rs 1
	cfg_mic_gain:       .rs 1
	cfg_mic_src:        .rs 1
	cfg_my_favorite:    .rs SIZE_FREQ
	cfg_onhook_act:     .rs 1
	cfg_mycall:         .rs 8
	cfg_my_mbusid:      .rs 4
	cfg_reject_0:       .rs SIZE_FREQ
	cfg_reject_1:       .rs SIZE_FREQ
	cfg_reject_2:       .rs SIZE_FREQ
	cfg_reject_3:       .rs SIZE_FREQ
	cfg_reject_4:       .rs SIZE_FREQ
	cfg_reject_5:       .rs SIZE_FREQ
	cfg_reject_6:       .rs SIZE_FREQ
	cfg_reject_7:       .rs SIZE_FREQ
	cfg_reject_8:       .rs SIZE_FREQ
	cfg_reject_9:       .rs SIZE_FREQ
	cfg_rptr_area_high: .rs SIZE_FREQ
	cfg_rptr_area_low:  .rs SIZE_FREQ
	cfg_rxband_high:    .rs SIZE_FREQ
	cfg_rxband_low:     .rs SIZE_FREQ
	cfg_freq_implied:   .rs SIZE_FREQ
	cfg_sc1_high:       .rs SIZE_FREQ
	cfg_sc1_low:        .rs SIZE_FREQ
	cfg_sc2_high:       .rs SIZE_FREQ
	cfg_sc2_low:        .rs SIZE_FREQ
	cfg_sc3_freq_0:     .rs SIZE_FREQ
	cfg_sc3_freq_1:     .rs SIZE_FREQ
	cfg_sc3_freq_2:     .rs SIZE_FREQ
	cfg_sc3_freq_3:     .rs SIZE_FREQ
	cfg_scan_wait:      .rs 1           ! SECONDS
	cfg_scan_pers:      .rs 1           ! MINUTES
	cfg_sqdelay:        .rs SIZE_MSEC
	cfg_sqhyst:         .rs 1           ! percent value
	cfg_sqlevel:        .rs 1           ! percent value
	cfg_sqtail:         .rs SIZE_MSEC
	cfg_step_rate:      .rs SIZE_MSEC
	cfg_txband_high:    .rs SIZE_FREQ
	cfg_txband_low:     .rs SIZE_FREQ
	cfg_txpwr:          .rs 1           ! percents

	cfg_txtone1:        .rs 8
	cfg_txtone2:        .rs 8
	cfg_txtone3:        .rs 8
	cfg_txtone4:        .rs 8
	cfg_txtone5:        .rs 8
	cfg_txtone6:        .rs 8
	cfg_txtone7:        .rs 8
	cfg_txtone8:        .rs 8

	cfg_afc_ctrl:       .rs 1 ! percent value
	cfg_deviation:      .rs 1 ! percent value
	cfg_lfu_vol:        .rs 1

	cfg_tx_timer:       .rs 1 ! minutes

	cfg_script_0:       .rs 8 ! executable scripts
	cfg_script_1:       .rs 8
	cfg_script_2:       .rs 8
	cfg_script_3:       .rs 8
	cfg_script_4:       .rs 8
	cfg_script_5:       .rs 8
	cfg_script_6:       .rs 8
	cfg_script_7:       .rs 8
	cfg_script_8:       .rs 8
	cfg_script_9:       .rs 8

	cfg_ctcss_idx:      .rs 1  ! TAB
	cfg_roger_idx:      .rs 1  ! TAB

    	cfg_cw_speed:       .rs 2  ! WORD
    	cfg_cw_pitch:       .rs 2  ! WORD

	cfg_dolby:          .rs 1  ! TAB

	cfg_offhook_act:    .rs 1  ! TAB, 0 NONE

	cfg_volt_warn:      .rs 1  ! PERCENT
	cfg_temp_warn:      .rs 1  ! PERCENT

	cfg_lazy_beep:      .rs 1  ! TAB, 0 OFF

	cfg_scan_listen:    .rs 1  ! SECOND
	cfg_scan_unreject:  .rs 1  ! MINUTE

	cfg_tx_delay:       .rs SIZE_MSEC
	
	cfg_charger_cycle:	.rs 1	! TAB, 0 OFF
	cfg_charger_method:	.rs 1	! TAB
	cfg_charger_v_end:	.rs 1	! BYTE
	cfg_charger_v_resume:	.rs 1	! BYTE
	cfg_charger_t_end:	.rs 1	! BYTE
	cfg_charger_t_resume:	.rs 1	! BYTE

cfg_end_area:

!----------

MEM_flags =  0 !  1 byte misc flags
MEM_rx    =  1 !  3 bytes rx freq
MEM_offtx =  4 !  3 bytes offset or separate tx
MEM_name  =  7 !  3 bytes name
MEM_size  = 10 !    bytes per memory total

MEM_EXIST  = 0x01
MEM_SCAN   = 0x02
MEM_DUPLEX = 0x10
MEM_OFFTX  = 0x20

	.org ram + 2048 - 100 * MEM_size
memories:

	.org ram + 2048          ! 2 kB for config and memories
end_memories:

size_memories = end_memories - memories
config_slack = memories - cfg_end_area

ASSERT(config_slack > 0)

workarea: ! XXX cook up some macros to give "safety" with LO(var)

volume:       .rs 1
rx_freq:      .rs SIZE_FREQ
tx_freq:      .rs SIZE_FREQ
duplex_state: .rs 1

scan_mode:    .rs 1  ! last scan modes used, a mask
scan_state:   .rs 1  ! 0 or ...
 STEPPING  = 1
 WAITING   = 2
 LISTENING = 3

mem_idx:      .rs 1
mem_flags:    .rs 1
mem_name:     .rs 3

end_nonvolatile: !=========================================================

tx_on:       .rs 1  ! LSbit for real txon, rest for "want"
tx_pinned:   .rs 1  ! xmit frequency is pinned down, separate from rx.

vco_freq:     .rs SIZE_FREQ
scratch_freq: .rs SIZE_FREQ

rx_div:      .rs 6  ! programmable divider + reference divider, longs
tx_div:      .rs 6  ! programmable divider + reference divider, longs

i2c_jmpbuf:  .rs 2  ! setjmp/longjmp stack state for errors.
i2c_MA:      .rs 1  ! shadow MA register (during i2c access)

dac_BCON:    .rs 1
lfu_regs:    .rs 4  ! All 4.

rssi:        .rs 1
rssi_prev:   .rs 1
pfb:         .rs 1
pfb_prev:    .rs 1
sig_peak:    .rs 1  ! for display purposes, peak here for 1 second

sqopen:      .rs 1
sq_forced:   .rs 1
sq_changed:  .rs 1
timer_sig:   .rs 1  ! ticks
timer_sq:    .rs 1  ! ticks

timer_step:  .rs 1    ! ticks
timer_scan:  .rs 1    ! seconds
timer_pers:  .rs 1 ! minutes

timer_fcn:   .rs 1  ! seconds

curr_chr:    .rs 1
prev_chr:    .rs 1
kbd_flags:   .rs 1
 SHIFT   = 1
 ALPHA   = 2
 KEYLOCK = 4

alpha_idx:   .rs 1
kbd_index:   .rs 1
kbd_buffer:  .rs 8
prt_buffer:  .rs 16 ! scratch for printouts
alpha_box:   .rs 1

timer_ticks:    .rs 1  ! ticks (gnah :)
timer_kbd_idle: .rs 1  ! ticks
timer_notices:  .rs 1  ! cleared every minute

timer_txon:     .rs 1  ! minutes

subseconds: .rs 1
seconds:    .rs 1
minutes:    .rs 1
hours:      .rs 1

pending_notices: .rs 1 ! any warnings/etc printed lately ?
delay_temp:      .rs 1
delay_batt:      .rs 1

afc_count:     .rs 2  ! Center measurement in raw form

menu_active: .rs 1 ! bool
menu_ptr:    .rs 2 ! current record in menu, top or sub
menu_topptr: .rs 2 ! toplevel ptr, recall when rising

!  A/D converter is in scan mode, INTAD used, ad_int refreshes
!  half of ad_regs per interrupt, uses ad_ptr for quickish [HL] stores
!  and there is another yucko hack with ring incrementing.

ad_ptr:  .rs 2
	.align 4
ad_regs:            ; ASSERT((ad_regs & 0xF) == 0)
ad_FSKL: .rs 1
ad_BCR:  .rs 1
ad_BTMP: .rs 1
ad_RSSI: .rs 1
ad_PFB:  .rs 1
ad_BATT: .rs 1
ad_TEMP: .rs 1
ad_LOCK: .rs 1
                    ASSERT(. == ad_regs + 8)

end_workarea:

	ASSERT(. <= workarea + 256)

!------------------------------------------------------------

#include "mbus.asm" /* get the variables */

	.org 0xFFFE
stack:

!----------------------------------------------------------------------
!
!
!
	.text
!--------------------
	.org 0x0000     ! /RESET
	di
	jmp _start

!--------------------
	.org 0x0004     ! /NMI - restart
	jmp 0

!
!  Flags are not tested when entrypoints
!  have only one unmasked source.
!  The flag will be automatically cleared (when vectoring ?).
!
!--------------------
	.org 0x0008     ! INTT1 - 112 Hz (INTT0 not used)
	jmp systick

!--------------------
	.org 0x0010     ! INT1 /INT2
	ei
	reti

!--------------------
	.org 0x0018     ! INTE0 - timer/event counter, NETFREE indication
	jmp netfree

!--------------------
	.org 0x0020     ! INTEIN INTAD - CI/TO edge, A/D complete (AD used)
	jmp adint

!--------------------
	.org 0x0028     ! INTST INTSR - serial port (both interrupts unmasked)
	jmp serint

	ASSERT(. <= 0x0060) ! catch overrun
!--------------------
	.org 0x0060     ! SOFTI - software interrupt (might be used)
	reti

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Call table
!
#define CALT_REC(x) tab_/**/x = (. - 0x0080) / 2; .word x;
	ASSERT(. <= 0x0080) ! catch overrun
!--------------------
	.org 0x0080

	ASSERT(. <= 0x00C0) ! End of call table

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  interrupt functions, no register saved yet
!

systick:
	ori PC, WDCLR
	exa
	exx

	mov A, [timer_ticks]
	sui A, 1
	aci A, 0
	mov [timer_ticks], A         ! crawls to 0, from max 255

	mov A, [timer_sig]
	sui A, 1
	aci A, 0
	mov [timer_sig], A           ! crawls to 0, from max 255

	mov A, [timer_kbd_idle]
	adi A, 1
	sbi A, 0
	mov [timer_kbd_idle], A      ! crawls to 255

	mov A, [timer_sq]
	gti A, 1
	?jr 1f
	sui A, 1
	mov [timer_sq], A            ! stays at 0 or 1, crawls to 1, from max 255
1:
	mov A, [timer_step]
	gti A, 1
	?jr 1f
	sui A, 1
	mov [timer_step], A          ! stays at 0 or 1, crawls to 1, from max 255
1:
	mov A, [subseconds]
	adi A, 1
	gti A, 111
	?jr 1f
	call asecond
	mvi A, 0
1:
	mov [subseconds], A

	ani PC, ~WDCLR
	exx
	exa
	ei
	reti

! each either returns or falls into next at overflow

asecond: !----------------------------------------

	call afc_meas        ! Save AFC count every second (could be tighter)

	mov A, [timer_scan]
	gti A, 1
	?jr 1f
	sui A, 1
	mov [timer_scan], A  ! stays at 0 or 1, crawls to 1 from 255
1:
	mov A, [timer_fcn]
	sui A, 1
	aci A, 0
	mov [timer_fcn], A   ! crawls to 0

	mov A, [seconds]     !----------------------
	adi A, 1             !
	mov [seconds], A     !
	gti A, 59            !
	?ret                 !
	mvi A, 0             !
	mov [seconds], A     !----------------------

aminute: !----------------------------------------
	mvi A, 0
	mov [pending_notices], A

	mov A, [timer_txon]
	sui A, 1
	aci A, 0
	mov [timer_txon], A

	mov A, [timer_pers]
	gti A, 1
	?jr 1f
	sui A, 1
	mov [timer_pers], A  ! stays at 0 or 1, crawls to 1 from 255
1:
	mov A, [minutes]     !-----------------------
	adi A, 1             !
	mov [minutes], A     !
	gti A, 59            !
	?ret                 !
	mvi A, 0             !
	mov [minutes], A     !-----------------------

ahour: !----------------------------------------
	mov A, [hours]       !-----------------------
	adi A, 1             !
	mov [hours], A       !
	gti A, 23            !
	?ret                 !
	mvi A, 0             !
	mov [hours], A       !-----------------------

aday: !----------------------------------------

	ret

!----------------------------------------------------------------------
!
!  Save current A/D half, prepare for next.
!  HL wraps back to ad_regs xxx0 from xxx8.
!
adint:
	exa
	exh
	lhld [ad_ptr]
	mov A, CR0
	stax [HL]+
	mov A, CR1
	stax [HL]+
	mov A, CR2
	stax [HL]+
	mov A, CR3
	stax [HL]+
	ani L, ~0x08    ; ASSERT((ad_regs & 0xF) == 0)
	shld [ad_ptr]   ! xxx4 when next round is 4,5,6,7; xxx0 when next 0,1,2,3
	mov A, L        ! x0 or x4
	ani A, 0x04     ! 00 or 04
	sll A           ! 00 or 08 (ANI2 bit)
	mov ANM, A
	skit INTFAD     ! fresh readings
	?nop
	exh
	exa
	ei
	reti

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  STARTUP
!

_start:

	mvi A, 0
	mov MM, A       ! will just use the external RAM
	lxi SP, stack
	mvi V, HI(workarea) ! DO NOT CHANGE V from workarea
	exa
	mvi A, 0
	mvi V, HI(workarea) ! DO NOT CHANGE V from workarea

	lxi HL, end_nonvolatile      ! past memories and config.
	lxi EA, 0
	mvi A, 0
1:
	stax [HL]+               ! clear
	deq EA, HL
	?jr 1b

	call cpu_init
	call mbus_init

	call enable_ints
	ei

	jmp main

!----------------------------------------------------------------------
!!----------------------------------------------------------------------
!!
!!  SYNTHESIZERS
!!
!!  By adding some extra bits,
!!  this works on both MB87006 and MB1501 PLLs.
!!                     10+7        11+7   dividers
!!
!!  Linear NA is (again) used to skip the N,A division.
!!  This time it would be simple;
!!    lxi HL, rx_div             ! 17 or 18 effective bits (max. (with 128/129))
!!    lxi DE, rx_N               ! receives N-number
!!    mov B, [cfg_prescaler]
!!    call divide_long_by_B      ! B replaced by A-number
!!
!!  MB87006 largest divisor 131071 * 10 kHz = 1310.710 MHz	(2^17-1)
!!                       128 * 128 * 25 kHz =  409.600 MHz
!!                       128 * 128 * 12.5   =  204.800 MHz
!!
!!  MB1501  largest divisor 262143 * 10 kHz = 2621.430 MHz	(2^18-1)
!!                       128 * 128 * 25 kHz =  409.600 MHz
!!                        64 *  64 * 25 kHz =  102.400 MHz (unsupported yet)
!!                        64 *  64 * 12.5   =   51.200 MHz (unsupported yet)
!!
!  Preparation. Once only. Nothing to do.
!  The extra MSbit in reference divider of MB1501 is set to 0,
!  so it has the same 128/129 prescaler like MB87006 cards.
!

synth_init:
	ret

synth_receive:

	mov A, [rx_div + 4]       ! extra bit or two
	call synth_byte
	mov A, [rx_div + 3]
	call synth_byte

	mvi A, 0xFF
	call synth_bit            ! C=1

	ori PB, RSEN
	nop                       ! xtal/3 = state, 4 states, 1 nop about 1usec ok
	nop
	ani PB, ~RSEN             ! end pulse.

	mov A, [rx_div + 2]
	call synth_byte       ! actually only 2 LSbits used ever
	mov A, [rx_div + 1]
	call synth_byte
	mov A, [rx_div + 0]
	call synth_byte

	mvi A, 0x00
	call synth_bit        ! C=0

	ori PB, RSEN
	nop
	nop
	ani PB, ~RSEN
	ret

synth_xmit:

	mov A, [tx_div + 4]       ! extra bit or two
	call synth_byte
	mov A, [tx_div + 3]
	call synth_byte

	mvi A, 0xFF
	call synth_bit            ! C=1

	ori PB, TSEN
	nop
	nop
	ani PB, ~TSEN

	mov A, [tx_div + 2]
	call synth_byte       ! actually only 2 LSbits used ever
	mov A, [tx_div + 1]
	call synth_byte
	mov A, [tx_div + 0]
	call synth_byte

	mvi A, 0x00
	call synth_bit        ! C=0

	ori PB, TSEN
	nop
	nop
	ani PB, ~TSEN
	ret

synth_byte:
	call 1f ; call 1f; call 1f; call 1f
	call 1f ; call 1f; call 1f

synth_bit:
1:
	sllc A
	?ani PA, ~SDA
	skn CY
	?ori PA, SDA
	nop
	nop
	ori PA, SCL      ! rising edge seems the active one
	nop
	nop
	ani PA, ~SCL
	ret

!
!  vco freq at [HL] into divisor/refdiv [DE] and back over freq.
!  _ref is also updated. XXX this could (should) be totally generic.
!  XXX 25 works down to 409 MHz, VHF could not work even with 12.5.
!  XXX Should parametrize prescalers too !
!  Area near 380...409 MHz uses 12.5 kHz (128/129 limitation from dual
!  modulus prescalers).
!
ponder_about_freq:

	mvi B, 25                    ! 25 kHz
	call divide_long_by_B        ! [DE] = [HL] / 25, B has remainder.

	nei B, 0
	?jmp ponder_takes_25         ! ?Not. exact division = accept.
	nei B, 1
	?jmp ponder_takes_25         ! ?Not. 1kHz offset = accept anyway.
	nei B, 24
	?jmp ponder_takes_25         ! ?Not. -1kHz offset = accept anyway.

	nei B, 12
	?jmp ponder_takes_12_5       !  go there when 12.5 works (rounded I/F)
	nei B, 13
	?jmp ponder_takes_12_5       !  go there when 12.5 works (F/I dednuor)

	mvi B, 20
	call divide_long_by_B        ! [DE] = [HL] / 20, B has remainder.

	nei B, 0
	?jmp ponder_takes_20         ! ?Not. exact division = accept.

! each ponder_takes_XXX still has remainder of division in B

ponder_takes_10:
	mvi B, 10
	call divide_long_by_B        ! redo /, shift would be a tad quicker.
	mvi C, 10
	lxi EA, 1280                 ! 12800 / 1280 gives 10 kHz,
	jmp ponder_continues

ponder_takes_20:
	mvi C, 20
	lxi EA, 640                  ! 12800 / 640 gives 20 kHz
	jmp ponder_continues

! after trying 25, the divisor must be multiplied by 2 and LSbit added

ponder_takes_12_5:
	mvi A, 0
	sub A, B           ! B can be 0 or 12(13). reduced into CY
	ldax [DE+0]
	rll A
	stax [DE+0]
	ldax [DE+1]
	rll A
	stax [DE+1]
	ldax [DE+2]
	rll A
	stax [DE+2]           ! *= 2 and LSbit added
	mvi C, 12
	lxi EA, 1024                 ! 12800 / 1024 gives 12.5 kHz
	jmp ponder_continues

ponder_takes_25:
	ldax [DE+2]
	eqi A, 0x00           ! 128 * 128 == 16384 == 0x004000
	?jr 1f
	ldax [DE+1]
	lti A, 0x40           ! choose 12.5 instead, for frequencies near 400 MHz
	?jr 1f
	jmp ponder_takes_12_5
1:
	mvi C, 25
	lxi EA, 512                  ! 12800 / 512 gives 25 kHz

ponder_continues:

	steax [DE+3]                 ! _ref saved (unused MSbyte always 0)

	push HL
	push DE
	pop HL
	pop DE                       ! exchange to recalc freq
	mov A, C
	nei A, 12
	?mvi A, 25                   ! yuckockoo
	mov B, A
	call multiply_long_by_B

	eqi C, 12
	?jr 1f
	ldax [DE+2]      ! div was got by / 25 * 2, fq is so div * 25 / 2
	slr A
	stax [DE+2]
	ldax [DE+1]
	rlr A
	stax [DE+1]
	ldax [DE+0]
	rlr A
	stax [DE+0]
1:
	ret

!
!  Refresh divisors and align back frequencies (into their effective values)
!

freq_changed:
	neiw LO(sq_forced), 0    ! sq NOT forced.
	?call squelch_now_closed

	! RX part

	call determine_rx_vco    ! I/F to the left I/F to the right

	lxi HL, vco_freq
	lxi DE, rx_div
	call ponder_about_freq

	call synth_receive      ! receiver PLL updated here.

	call ocv_xr_enimreted

	! TX part (potentially in vain)

	call determine_tx_freq

	lxi HL, tx_freq
	lxi DE, tx_div          ! for later use
	call ponder_about_freq

	ret

ocv_xr_enimreted:

	lxi HL, vco_freq
	lxi BC, cfg_if_freq
	lxi DE, rx_freq

	mov A, [cfg_if_dir]
	eqi A, 0
	?jmp add_longs    
	jmp subtract_longs    ! normally, rx=vco-if


determine_rx_vco:

	lxi HL, rx_freq
	lxi BC, cfg_if_freq
	lxi DE, vco_freq

	mov A, [cfg_if_dir]
	eqi A, 0
	?jmp subtract_longs
	jmp add_longs        ! normally, vco=rx+if


! rx_freq or duplex_state has changed, what to do to tx_freq
! HL=rx, DE=tx, add, sub, copy what is needed

determine_tx_freq:

	lxi HL, rx_freq         ! generally in command of tx location
	lxi BC, cfg_duplex_off  ! increment/decrement maybe
	lxi DE, tx_freq

	mov A, [duplex_state]
	eqi A, 0
	?jr 1f
	jmp copy_long           ! 0: DE=HL
1:
	eqi A, 1
	?jr 2f
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?jmp add_longs
	jmp subtract_longs     ! 1: normally, DE=HL-BC
2:
	eqi A, 2
	?jr 3f
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?jmp subtract_longs
	jmp add_longs          ! 2: normally, DE=HL+BC
3:
	ret         ! 3, tx and rx are unconnected. do nothing.


! fixups for flipping with R key

enter_reverse_duplex:
	lxi HL, rx_freq
	lxi BC, cfg_duplex_off
	lxi DE, rx_freq
	mov A, [cfg_duplex_dir]
	nei A, 0
	?call subtract_longs
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?call add_longs
	ret

leave_reverse_duplex:
	lxi HL, rx_freq
	lxi BC, cfg_duplex_off
	lxi DE, rx_freq
	mov A, [cfg_duplex_dir]
	nei A, 0
	?call add_longs
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?call subtract_longs
	ret

! Restore into duplex (2 to 1)

ok_with_reverse_duplex:
	call leave_reverse_duplex  ! 2 to 0 fixups
	mvi A, 1
	mov [duplex_state], A

	call freq_changed
	jmp redraw

!  If inside rptr low/high, set duplex, else normal

set_duplex_wrt_freq:

	lxi HL, rx_freq
	mviw LO(duplex_state), 0     ! Assume simplex

	lxi DE, cfg_rptr_area_high   ! must be below this for duplex
	call skip_if_freq_below
	ret                          ! skipped if below higher limit
	lxi DE, cfg_rptr_area_low    ! below this simplex
	call skip_if_freq_below
	mviw LO(duplex_state), 1     ! skipped if below lower limit
	ret

!  Is it legal to transmit ?

skip_if_tx_legal:

	lxi HL, tx_freq

	lxi DE, cfg_txband_low       ! lower limit
	call skip_if_freq_above
	ret                          ! illegal return, skipped if above lower
	lxi DE, cfg_txband_high      ! must be below this to xmit
	call skip_if_freq_below
	ret                          ! illegal return, skipped if below upper
	rets                         ! legal.

!----------------------------------------------------------------------
wont_actually_xmit:
	call warning; .asciz "ILLEGAL!"  ! I'm sorry Dave, you can't do that.
	ret

start_xmit:
	mov A, [cfg_tx_timer]
	adi A, 1
	sbi A, 0              ! translate 0 to 1 etc, steps are rough (1/minute)
	mov [timer_txon], A

	oriw LO(tx_on), 1

	call skip_if_tx_legal
	jmp wont_actually_xmit ! Sorry.

	ori PA, CRM            ! relays etc
	call start_tx_delay

	ani PA, ~TSLG
	ori PB, TSON          

	call disconnect_audio  ! enough delay for the txpll to wakeup ?
	call DAC_update

	call synth_xmit

	call update_deviation
	call draw_currfreq     ! enough delay for the txpll to lock ?

	call wait_tx_delay

	ori PA, TSLG
	ori PB, TXON

	call ctcss_maybe

	call mbus_sendsig     ! SERV into ROAM
	mvi A, 1
	mov [sq_changed], A   ! will be picked up when returning to rx
	ret

stop_xmit:
	aniw LO(tx_on), ~1

stop_xmit_stealth:

	ani PB, ~TXON
	call start_tx_delay

	call synth_receive
	call draw_currfreq     ! delay
	ani PB, ~TSON

	oniw LO(sq_forced), 1
	?call squelch_now_closed
	offiw LO(sq_forced), 1
	?call connect_audio

	call i8253_tone_off   ! maybe

	call wait_tx_delay
	ani PA, ~CRM          ! relays etc

	ret

start_tx_delay:
	lxi HL, cfg_tx_delay
	ldeax [HL]
	mvi A, 9
	eadd EA, A
	mvi A, 10
	div A
	mov A, EAH
	eqi A, 0
	?lxi EA, 255
	mov A, EAL
	mov [timer_ticks], A   ! txd timer
	ret

wait_tx_delay:
1:
	mov A, [timer_ticks]   ! txd timer wait
	eqi A, 0
	?jr 1b
	ret

!  Is it legal to receive ? for USA only
skip_if_rx_legal:

	lxi HL, rx_freq

	lxi DE, cfg_rxband_low       ! lower limit
	call skip_if_freq_above
	ret                          ! illegal return, skipped if above lower
	lxi DE, cfg_rxband_high      ! must be below this to xmit
	call skip_if_freq_below
	ret                          ! illegal return, skipped if below upper
	rets                         ! legal.


!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  MC144111 DAC
!
!  There are 2816 different PowerControl steps (in theory),
!  the coarse dac can have 64 values, and the fine dac 44.  XXX 
!

DAC_init:
	mvi A, 0x7F         ! 6bit value will be 1F (half of max 3F)
	mov [dac_BCON], A

	jmp DAC_update

DAC_update:
	ani PC, ~DADIS              ! select DAC

	! cfg_afc_ctrl is percent, transfer into byte and just use 6 MSbits

	mov A, [cfg_afc_ctrl]
	call map_percents_to_byte
	call DAC_byte               ! AFC

	mov A, [dac_BCON]
	call DAC_byte               ! BCON  - OH3NWQ - hey dabble on this

	! use Vesku's table (thanks !) to map percents to nice TX power levels

	mov A, [cfg_txpwr]
	sll A                       ! word array, offsets 0, 2, ... 200
	lxi EA, txpwr_curve
	eadd EA, A
	dmov HL, EA

	ldax [HL]+
	sll A
	sll A
	call DAC_byte               ! PC coarse with tabled 6 bits

	ldax [HL]+
	sll A
	sll A
	call DAC_byte               ! PC fine with tabled 6 bits

	nop
	nop
	nop
	nop
	ori PC, DADIS               ! latch and unselect
	ret

! send 6 MSbits

DAC_byte:
	call 1f; call 1f; call 1f;    ! 3 bits
	call 1f; call 1f              ! 2 bits, and FALLTHRU for last.

DAC_bit:
1:
	sllc A
	?ani PA, ~SDA
	skn CY
	?ori PA, SDA
	nop
	nop
	nop
	nop
	ori PA, SCL
	nop
	nop
	nop
	nop
	ani PA, ~SCL      ! falling edge seems the active one for DAC
	nop
	nop
	ret

!----------------------------------------------------------------------
!!----------------------------------------------------------------------
!!
!!  I2C with DATA and DTC (ONLY INPUTS in Port A !)
!!
!!  Original circuits do not include pullups, use of these functions
!!  requires replacing any 100k pulldowns into usable pullups.
!!  It is okay to make these mods at the "SIS replacement card".
!!  PA Output latches are 0 always, and MA is used to pull or release
!!  the pin.
!!
!  We allow clocksync but not very long.
!
!  Use i2c_read and i2c_write,
!  address (R/W bit overridden) in A
!  buffer without address-byte in [HL]
!  buffer length in C
!  A, B, C, HL destroyed.

!---
!  skip-return on success, normal return on busy/timeout/etc error.

i2c_read:
	sspd [i2c_jmpbuf]      ! setjmp

	call i2c_start

	ori B, 0x01            ! reading. set R//W bit
	call i2c_write_byte
	jr 2f
1:
	call i2c_read_byte
	mov A, B
	stax [HL]+
2:
	dcr C
	?jr 1b
	jmp i2c_success

!---
i2c_write:
	sspd [i2c_jmpbuf]      ! setjmp

	call i2c_start

	ani B, ~0x01           ! writing. drop R//W bit
	call i2c_write_byte
	jr 2f
1:
	ldax [HL]+
	mov B, A
	call i2c_write_byte
2:
	dcr C
	?jr 1b
	jmp i2c_success

!---
!  Try to create a stop and longjump to caller with skip.

i2c_timeout:
i2c_noack:
i2c_busy:
	mvi A, DATA            ! so DTC is output
	mov MA, A              ! clock low
	mvi A, 0               ! 0 is both output
	mov MA, A              ! data low too
	ori A, DTC             ! 1 is input
	mov MA, A              ! clock released
	ori A, DATA            ! 1 inputs
	mov MA, A              ! data released too

	lspd [i2c_jmpbuf]      ! zap
	ret                    ! "sorry."

i2c_success:
	call i2c_stop
	rets                   ! "okay", skip failure jump below calling line

!---
i2c_release_clock:
	oriw LO(i2c_MA), DTC   ! 1 is input
	ldaw LO(i2c_MA)
	mov MA, A              ! clock released.

	mvi A, 255             ! guard
1:
	nop
	nop
	offi PA, DTC           ! clock still low
	?jr 1f                 ! ?Not. delayers done.
	dcr A
	?jr 1b
	jmp i2c_timeout        ! go unwind stack and fail miserably
1:
	ret

!---
i2c_pull_clock:
	aniw LO(i2c_MA), ~DTC  ! 0 is output
	ldaw LO(i2c_MA)
	mov MA, A              ! clock pulled.
	ret

!---
i2c_release_data:
	oriw LO(i2c_MA), DATA  ! 1 is input
	ldaw LO(i2c_MA)
	mov MA, A              ! data released.
	ret

!---
i2c_pull_data:
	aniw LO(i2c_MA), ~DATA ! 0 is output
	ldaw LO(i2c_MA)
	mov MA, A              ! data pulled.
	ret

!---
i2c_get_ack:
	call i2c_release_data  ! to be able to see the ack

	mvi A, 255             ! guard
1:
	nop
	nop
	oni PA, DATA           ! data still high
	?jr 1f                 ! ?Not. slave receiver pulls it for ack.
	dcr A
	?jr 1b
	jmp i2c_noack          ! go unwind stack and fail miserably
1:
	ret

!---
i2c_start:
	mviw LO(i2c_MA), DTC | DATA
	ldaw LO(i2c_MA)
	mov MA, A

	ani PA, ~(DTC | DATA)  ! output latches low during the whole schebang

	oni PA, DATA
	?jmp i2c_busy
	oni PA, DTC
	?jmp i2c_busy

	call i2c_pull_data     ! START
	jmp i2c_pull_clock

!---
i2c_stop:
	call i2c_pull_data
	call i2c_release_clock
	jmp i2c_release_data   ! STOP

!---
i2c_clock:
	call i2c_release_clock
	jmp i2c_pull_clock

!---
i2c_bit_out:
	sllc B
	?jr 1f
	call i2c_release_data
	jmp i2c_clock
1:
	call i2c_pull_data
	jmp i2c_clock

!---
i2c_write_byte:
	call i2c_bit_out
	call i2c_bit_out
	call i2c_bit_out
	call i2c_bit_out

	call i2c_bit_out
	call i2c_bit_out
	call i2c_bit_out
	call i2c_bit_out

	call i2c_get_ack
	jmp i2c_clock

!---
i2c_bit_in:
	call i2c_release_clock
	sll B
	offi PA, DATA
	?ori B, 0x01
	jmp i2c_pull_clock
	
!---
i2c_read_byte:
	call i2c_release_data

	call i2c_bit_in
	call i2c_bit_in
	call i2c_bit_in
	call i2c_bit_in

	call i2c_bit_in
	call i2c_bit_in
	call i2c_bit_in
	call i2c_bit_in

	eqi C, 0
	?call i2c_pull_data    ! ack when not reading last byte

	jmp i2c_clock

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  AMU/LE (deviation latch) 3 LSbits control modulation, 74259. D0 A0..2
!  SVS deviation kept at minimum after /RESET

update_deviation:
	mov A, [cfg_deviation]
	call map_percents_to_byte
	slr A  ! 7F
	slr A  ! 3F
	slr A  ! 1F
	slr A  ! 0F
	slr A  ! 07
	mov [AMULE + 0], A
	slr A  ! 03
	mov [AMULE + 1], A
	slr A  ! 01
	mov [AMULE + 2], A
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  buffer at HL&C, crc kept in EA (prep to FFFF)
!
crc:
	push DE
	push BC
	push HL                   !  crc = crchi ^ crc16_table[crclo ^ c]
	jr 2f
1:
	mov A, EAL                ! old crclo
	xrax [HL]+                ! crclo ^ c
	mov E, A                  ! is index into both tabs
	mov A, EAH                ! old crchi
	mvi D, HI(crctbl_lo)      ! lower 8 bits of crc word ...
	xrax [DE]                 ! ... against old crchi ...
	mov EAL, A                ! ... is new crclo
	mvi D, HI(crctbl_hi)      ! upper 8 bits of crc word ...
	ldax [DE]                 ! ... is ...
	mov EAH, A                ! ... new crchi
2:
	dcr C
	?jr 1b
	pop HL
	pop BC
	pop DE
	ret

!----------------------------------------------------------------------
!!----------------------------------------------------------------------
!!
!!  MAS7825 NMT-modem
!!
!! XXX "our MSK moron format"
!! XXX 6 useful bytes and crc16: Cs ss ss dd dd dF crchi crclo
!! XXX bit- and frame-syncs there (sent MSbit 1st)
!! 1010101010101010  AAAA  16 bits
!! 1010101010101010  AAAA
!! 1010101010101010  AAAA
!! 1010101010101010  AAAA
!! 1010101010101010  AAAA  lotsa bitsa synca
!! 1100010011010111  C4D7  MPT-1327 SYNC word
!! and a trailer     0000  also after crc at the end
!!
!! Doesn't immediately resemble the NMT ones (sent ? bit 1st)
!! 101010101010101 bitsync   15 bits
!! 11100010010     framesync 11 bits
!!
!! MPT-1327 SYNT word
!! 0011101100101000  3B28 (doesn't help us a bit).
!!
!! NMT code writes 55 D5 23 in the head, so the data is LSbit 1st ?
!! inverted:
!! 10101010101010
!! 1111000100
!! additional 1 and then 0 must be sent to complete the NMT-framesync

modem_init:
	call modem_hunt
	ret

modem_hunt:
	mvi A, 0xE0             ! clear rxtx, timer, hunt mode
	mov [MODEM_CSR], A
	nop
	mvi A, 0x11             ! set SHM RINTE
	mov [MODEM_CSR], A
	ret

! HL&C
! syncs and crc added here

modem_xmit:
	nei C, 0
	?ret                    ! huh

	lxi EA, 0xFFFF
	call crc                ! payload only, EA used a bit below

	mvi A, 0x02             ! set TINTE
	mov [MODEM_CSR], A

	mvi A, 0x55
	call modem_xmit_1       ! sync words
	mvi A, 0xD5
	call modem_xmit_1
	mvi A, 0x23
	call modem_xmit_1

	jr 2f                   ! start loop
1:
	ldax [HL]+
	call modem_xmit_1
2:
	dcr C
	?jr 1b

	mov A, EAH
	xri A, 0xFF
	call modem_xmit_1       ! MSByte 1st
	mov A, EAL
	xri A, 0xFF
	call modem_xmit_1
	mvi A, 0x00
	call modem_xmit_1       ! junk
1:
	mov A, [MODEM_CSR]
	offi A, 0x08            ! TXE clear (transmit in progress no more)
	?jr 1b

	call modem_hunt         ! return to receive
	ret

modem_xmit_1:
1:
	mov B, [MODEM_CSR]
	oni B, 0x04             ! TFLAG set. Buffer empty.
	?jr 1b
	mov [MODEM_DATA], A
	ret

modem_check:
	mov A, [MODEM_CSR]
	oni A, 0x01             ! RFLAG set. Byte available.
	?ret
	mov A, [MODEM_DATA]
	! handle byte XXX
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  i8253
!
!  Center measurement is done with TMR0 and TMR1
!  CLK0 is "455 kHz"
!  CLK1 is 921600 Hz
!  OUT1 is inverted into GATE0
!
!  TMR1 runs in mode 0, gives almost exact gate for TMR0
!  (error is >= 0 and < one CLK1)
!  TMR0 run in mode 2, reloads from each gate and
!  downcounts to 0 during the gate. Ideal end count is 0.
!
!!----------------------------------------------------------------------
!!
!!  CTCSS & CCIR & misc txtones require a rewire of TMR2.
!!
!!  Locate the i8253 on the audiocard. There is a 4 legged double diode
!!  near the timer chip. Cut the trace connecting pins 1 and 2 of the diode.
!!  This prevents the cpu from being interrupted by the tones.
!!
!!  Locate traces coming into the i8253 pins 20 and 24, from the
!!  4040 divider chip pins 7 and 12. You'll see testing points in
!!  both traces. Cut the trace connecting pins 12 and 24, make the
!!  cut near 4040. Next to the trace is the another trace in question.
!!  Solder very short wire to connect pin 24 into the pins 7 and 20.
!!  Pin 12 is left unconnected by this mod.
!!  This gives a nice 921600 Hz input for the TMR2 of the i8253 too.
!!
!!  The double diode pin 4, connected to timer pin 23, emits the
!!  tones. 5 volt square wave. Both CCIR and CTCSS.
!!  When not emitting a tone the output is quiet (+5V) (digital noise ?)
!!  so no switch is needed for the CTCSS (?). CCIR is switched on
!!  and off as needed with the XMIC input.
!!
!!  CCIR is routed to MAS7845 XMIC pin 34. 100kohm and 1kohm
!!  in series to ground from the diode. 100nF from the midpoint
!!  into MAS pin. There are NMT audio filters ahead, do not worry.
!!
!!  CTCSS is another case. Pick your filters, voltage dividers,
!!  insertion point....
!!
!!  CLK2 is 921600Hz after the mod (originally 7200 Hz). GATE2 is high.
!!  OUT2 is tone output square wave.  921.6k / X = CTCSS, so, X = 921.6k / CTCSS

TMR2_HZ = 921600         ! after the rewire

! these are handpicked to produce no rounding errors

AFC_CNT0 = 31850         ! ideal count for exact 455kHz input
AFC_CNT1 = 64512         ! about 70 msec of gate for TMR0

! Above gives one tick in CNT0 for each 15 Hz of error from 455 KHz

i8253_init:

	mvi A, 0b00110100        ! TMR0, LSB then MSB, rate gen (2), binary count
	mov [i8253_CTRL], A      ! control word

	mvi A, AFC_CNT0 % 256
	mov [i8253_TMR0], A      ! CNT0 LSB
	mvi A, AFC_CNT0 / 256
	mov [i8253_TMR0], A      ! CNT0 MSB

	mvi A, 0b01110000        ! TMR1, LSB then MSB, terminal count, binary count
	mov [i8253_CTRL], A      ! control word

	call afc_meas

	call i8253_tone_off
	ret

afc_meas:
	mov A, [i8253_TMR0]      ! CNT0 LSB  TMR0 is stopped from gate
	mov [afc_count + 0], A
	mov A, [i8253_TMR0]      ! CNT0 MSB
	mov [afc_count + 1], A

	mvi A, AFC_CNT1 % 256
	mov [i8253_TMR1], A      ! CNT1 LSB
	mvi A, AFC_CNT1 / 256
	mov [i8253_TMR1], A      ! CNT1 MSB, gate reloads TMR0

	ret

i8253_tone_off:
	mvi A, 0b10010000        ! TMR2, LSB only, terminal count, binary count
	mov [i8253_CTRL], A      ! control word

	mvi A, 1
	mov [i8253_TMR2], A      ! OUT2 soon rises and stays
	ret

i8253_tone_load:

	mvi A, 0b10110110        ! TMR2, LSB then MSB, square wave, binary count
	mov [i8253_CTRL], A      ! control word

	mov A, EAL
	mov [i8253_TMR2], A      ! CNT2 LSB
	mov A, EAH
	mov [i8253_TMR2], A      ! CNT2 MSB and OUT2 wiggles

	ret


!
!  EA contains Hz for a tone out from TMR2.
!  Tradition of yucko solutions continues:
!  to avoid division by 9+ bits, this reduces the divisor into 8 bits
!  by predividing it with powers of two. Result is then divided
!  with the same power. Accuracy gets worse for over 255 Hz,
!  but those are just "courtesy" tones (ccir is handled separately).
!
!  Check (for fun):
!  921600 / 1446 Hz = 637
!  921600 / 180 / 2 / 2 / 2 = 640
!  921600 / 640 = 1440 Hz
!
i8253_tone_hz:

	push BC

	! reduction of divisor

	mvi C, 0         ! count number of shifts
1:
	mov A, EAH       ! divisor small enough ?
	nei A, 0
	?jr 1f           ! now in 8 bits
	dslr EA          ! another /= 2 (could do something with the CYs ?)
	adi C, 1
	jr 1b            ! more ?
1:
	mov A, EAL       ! reduced divisor
	mov B, A

	! 24/8 division

	lxi EA, TMR2_HZ / 256    ! 2 MSBytes
	div A                    ! 1st divide
	dmov HL, EA              ! H is surely 0, save L
	lxi EA, TMR2_HZ % 65536  ! 2 LSbytes
	mov EAH, A               ! smack remainder from above
	div B                    ! second divide (remainder ignored)
	mov A, L
	mov EAH, A               ! EA has result of divide

	! fix of the result
1:
	nei C, 0                 ! still more shifts needed.
	?jr 1f
	dslr EA                  ! another /= 2
	sui C, 1
	jr 1b                    ! more ?
1:
	call i8253_tone_load     ! play it (the count)

	pop BC
	ret

!
!  Constant time (in BC XXX scale) of given (in A) DTMF tone
!
i8253_synthesize_dtmf:

	! map A into HL and DE, tone pair

	! XXX

	lxi EA, 0              ! to compare BC against at the end

	mvi A, 0b10010000      ! TMR2, LSB only, terminal count, binary count
	mov [i8253_CTRL], A    ! control word

	! use nmi to bail this out ? always 400 ms tones then

	di                     ! loop timing critical

	! watchdog tickle
	! calculate next sample, lowtone + hightone, position ptrs over links
	! load timer 2 with the sample
	! bump samplepointers from the links.
	! loop more or not.

#if nmi_hacko
	lxi BC, i8253_TMR2
1:
	ldax [HL]+          !  7
	addx [DE]+          ! 11 in case 'twist' is needed, the tables have it
	mov [BC], A         !  7 CNT2 LSB
	ldax [HL]           !  7
	mov L, A            !  4
	ldax [DE]           !  7
	mov E, A            !  4
	jr 1b               ! 10
nmi_warp_me_here:
	                    ! 57 states. 64.674 kHz PWM
#else

1:
	xri PC, WDCLR       ! 20

	ldax [HL]+          !  7
	addx [DE]+          ! 11 in case 'twist' is needed, the tables have it
	mov [i8253_TMR2], A ! 17 CNT2 LSB

	ldax [HL]           !  7
	mov L, A            !  4
	ldax [DE]           !  7
	mov E, A            !  4

	dcx BC              !  7
	deq EA, BC          ! 11 zero.
	?jr 1b              ! 10 ?Not. more.
	                    !--------------
	                    ! 105 states.  1 state = 1/fXTAL/3. 35.109 kHz PWM
	                    ! 28.48 usec
#endif

	ei

	jmp i8253_tone_off

!----------------------------------------------------------------------
!
! CTCSS -------------------------------------------------------------
!
!  67.0  69.3  71.9  74.4  77.0  79.7  82.5  85.4
!  88.5  91.5  94.8  97.4 100.0 103.5 107.2 110.9
! 114.8 118.8 123.0 127.3 131.8 136.5 141.3 146.2
! 151.4 156.7 162.2 167.9 173.8 179.9 186.2 192.8
! 203.5 206.6 210.7 218.1 225.7 229.1 233.6 241.8
! 250.3 254.1
!
! 921600 /  67 = 13755, 921600 / 13755 =  67.00,  6700 /  67.0 = 100% ok
! 921600 /  82 = 11239. 921600 / 11239 =  82.00,  8200 /  82.5 = 99.39% hmm
! 921600 /  83 = 11157. 921600 / 11157 =  82.60,  8260 /  82.5 = 100.12% ok
! 921600 / 127 =  7256. 921600 /  7256 = 127.01, 12701 / 127.3 = 99.77% ok
! 921600 / 254 =  3628. 921600 /  3628 = 254.02, 25402 / 254.1 = 99.97% ok
!
!----------------------------------------------------------------------
!
!
ctcss_maybe:
	mov A, [cfg_ctcss_idx]
	nei A, 0
	?jmp i8253_tone_off      ! Silence timer (part paranoia, it's quick anyway)

	call map_idx_to_txtone   ! gives us [HL]
	jmp i8253_tone_off       ! skipped if ok idx used.

	call str2i               ! CTCSS Hz into EA
	lxi HL, 0
	dne EA, HL
	?jmp i8253_tone_off      ! Hmph. Indexes empty string.

	jmp i8253_tone_hz        ! hertz

!----------------------------------------------------------------------
!
! CCIR ---------------------------------------------------------------
! 
! Tone #   EIA    CCIR   ZVEI1   ZVEI2   ZVEI3   PZVEI     EEA
!                                        DZVEI              
! 0        600    1981    2400    2400    2200    2400    1981
! 1        741    1124    1060    1060     970    1060    1124
! 2        882    1197    1160    1160    1060    1160    1197
! 3       1023    1275    1270    1270    1160    1270    1275
! 4       1164    1358    1400    1400    1270    1400    1358
! 5       1305    1446    1530    1530    1400    1530    1446
! 6       1446    1540    1670    1670    1530    1670    1540
! 7       1587    1640    1830    1830    1670    1830    1640
! 8       1728    1747    2000    2000    1830    2000    1747
! 9       1869    1860    2200    2200    2000    2200    1860
! A       2151    2400    2800     885     825     970    1055
! B       2435     930     810     810     740     810     930
! X/C     2010    2247     970     740    2600    2800    2247
! D       2295     991     885     680     885     885     991
! R/E      459    2110    2600     970    2400    2600    2110
! F      No/tone  1055     680    2600     680     680    2400
! 
! Timing
! Preamble 673ms 673ms   673ms   673ms   673ms   673ms   673ms
! Gap       65ms  65ms    65ms    65ms    65ms    65ms    65ms
! Tone      33ms  40ms   100ms   100ms   100ms   100ms   100ms
! X Tone    65ms  40ms   100ms   100ms   100ms   100ms   100ms
! 
! The Preamble is used as a battery saving mechanism, similar to todays
! digital pagers, thus the pager looks for its preamble, if not heard it
! shuts off to standby mode. Not all systems use the Preamble, that is why
! its called 5/6 tone paging. You may only have 5 tones when not using the
! Preamble.
! 
! In 5/6 tone paging a consecutive number is never sent. thus a pager with
! capcode 1-12344, would be sent using the a Preamble tone of 1/600Hz,
! followed by a 65ms gap of silence, then 2/882Hz, 3/1023Hz, 4/1164Hz each
! 33ms long, the second four is transmitted using the R (Repeat) Tone of
! R/459Hz.
! 
! The second address of a pager is activated by sending the X tone after the
! pagers capcode, thus 1-12345X.
! 
! The chart above inlcudes both 5/6 Tone & HSC Tones. For 5/6 Tone pagers only
! Tones 0-9, X, & R are used. Tones A-F are for use in HSC Pagers
! and 5/6 Tone ANI systems.
! 
! Made a program to check CCIR. Much less than 1% error in all tones.
!---------------------------------------------------------------------

ccir_tab:
	.word   465 ! 0   norm 1981   our 1981.9   100.0
	.word   819 ! 1   norm 1124   our 1125.3   100.1
	.word   769 ! 2   norm 1197   our 1198.4   100.1
	.word   722 ! 3   norm 1275   our 1276.5   100.1
	.word   678 ! 4   norm 1358   our 1359.3   100.1
	.word   637 ! 5   norm 1446   our 1446.8   100.1
	.word   598 ! 6   norm 1540   our 1541.1   100.1
	.word   561 ! 7   norm 1640   our 1642.8   100.2
	.word   527 ! 8   norm 1747   our 1748.8   100.1
	.word   495 ! 9   norm 1860   our 1861.8   100.1
	.word   384 ! A   norm 2400   our 2400.0   100.0
	.word   990 ! B   norm  930   our  930.9   100.1
	.word   410 ! X/C norm 2247   our 2247.8   100.0
	.word   929 ! D   norm  991   our  992.0   100.1
	.word   436 ! R/E norm 2110   our 2113.8   100.2
	.word   873 ! F   norm 1055   our 1055.7   100.1
	.word     1 ! or else ! (hundreds of kHz wont pass the filters)

!----------------------------------------------------------------------
!
!  HL points to serie, C has length
!!
!!  "LL8 911" would transmit CCIR like
!!    120 msec of 8
!!     40 msec of silence
!!     40 msec of 9
!!     40 msec of 1
!!     40 msec of E
!!
!!  40 msec is not very exact...
!

txtone_len:
	mvi B, 0
1:
	ldax [HL+B]
	nei A, 0
	?jr 1f
	adi B, 1
	gti B, 7
	?jr 1b
1:
	mov A, B
	mov C, A
	ret
	
ccir_xmit:
	call LFU_select_xmic
	mvi E, -1             ! no previous tone.
	jre 3f                ! start loop for 1..8 chrs
1:
	ldax [HL]+
	eqi A, 'L'
	?jr 2f
	adi B, 6              ! make it (next chr) longer
	dcr C
	?jr 1b                ! what is that next one ?
	ret                   ! longer nothing ? okay.
2:
	call map_chr_to_hex
	nea A, E              ! not same.
	?mvi A, 0xE           ! ?Not. repeat tone then.
	mov E, A              ! remember prev tone.
	push HL
	call ccir_xmit_1
	pop HL
	mov A, B
	call pause            ! tone duration
3:
	mvi B, 6              ! default length for next tone
	dcr C
	?jr 1b

	call i8253_tone_off
	call LFU_select_mic
	ret

ccir_xmit_1:
	lti A, 0x10        ! 16 possibilities 0..9, A..F, else silence...
	?mvi A, 0x10       ! ... here.
	sll A              ! word array
	lxi EA, ccir_tab
	eadd EA, A
	dmov HL, EA
	ldeax [HL]          ! count value into EA

	jmp i8253_tone_load ! raw count

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  LFU
!

LFU_init:
	! FSKT 00 bit 3    connect transmitted data
	! FSKE 00 bit 4    connect received data
	! TXP  00 bit 5    supply to tx parts and 4kHz filter
	mvi A, 0b110000 | 0x00
	mov [lfu_regs + 0], A

	call update_LFU_vol

	call update_LFU_come

	! S    11 bit 0    connect MIC
	! XS   11 bit 1    connect XMIC
	! AGCE 11 bit 3    tx audio agc enable
	! SVE  11 bit 4    connect supervisory signal loopback
	mvi A, 0b001001 | 0xC0
	mov [lfu_regs + 3], A

	jmp update_LFU

update_LFU_vol:
	! VOL  01 bit 3..0 rx audio volume
	! SPK  01 bit 4    rx audio connect
	mov A, [cfg_lfu_vol]
	lti A, 0xF
	?mvi A, 0xF
	aniw LO(lfu_regs + 1), ~0b001111          ! volume bits away
	oraw LO(lfu_regs + 1)
	ori A, 0x40
	staw LO(lfu_regs + 1)

	jmp update_LFU_one

update_LFU_come:
	! H    10 bit 2    rx audio connect
	! RXP  10 bit 3    rx parts supply
	! COME 10 bit 4    compander enable
	! MICO 10 bit 5    connect mics, "1" is on. aka TXDE.
	mvi A, 0b101100 | 0x80
	staw LO(lfu_regs + 2)
	mov A, [cfg_dolby]
	eqi A, 0
	?oriw LO(lfu_regs + 2), 0b010000
	ldaw LO(lfu_regs + 2)

	jmp update_LFU_one

LFU_select_mic:
	! FSKT 00 bit 3    connect transmitted data
	aniw LO(lfu_regs + 0), ~0b001000          ! FSKT OFF
	ldaw LO(lfu_regs + 0)
	call update_LFU_one

	! MICO 10 bit 5    connect mics, "1" is on. aka TXDE.
	oriw LO(lfu_regs + 2), 0b100000           ! mics ON
	ldaw LO(lfu_regs + 2)
	call update_LFU_one

	! S    11 bit 0    connect MIC
	! XS   11 bit 1    connect XMIC
	oriw LO(lfu_regs + 3),  0b000001          ! MIC ON
	aniw LO(lfu_regs + 3), ~0b000010          ! XMIC ON
	ldaw LO(lfu_regs + 3)
	jmp update_LFU_one

LFU_select_xmic:
	! FSKT 00 bit 3    connect transmitted data
	aniw LO(lfu_regs + 0), ~0b001000          ! FSKT OFF
	ldaw LO(lfu_regs + 0)
	call update_LFU_one

	! MICO 10 bit 5    connect mics, "1" is on. aka TXDE.
	oriw LO(lfu_regs + 2), 0b100000           ! mics ON
	ldaw LO(lfu_regs + 2)
	call update_LFU_one

	! S    11 bit 0    connect MIC
	! XS   11 bit 1    connect XMIC
	oriw LO(lfu_regs + 3),  0b000010          ! XMIC ON
	aniw LO(lfu_regs + 3), ~0b000001          ! MIC OFF
	ldaw LO(lfu_regs + 3)
	jmp update_LFU_one

LFU_select_fsk:
	! MICO 10 bit 5    connect mics, "1" is on. aka TXDE.
	aniw LO(lfu_regs + 2), ~0b100000         ! mics OFF
	ldaw LO(lfu_regs + 2)
	call update_LFU_one

	! FSKT 00 bit 3    connect transmitted data
	oriw LO(lfu_regs + 0), 0b001000          ! FSKT ON
	ldaw LO(lfu_regs + 0)
	jmp update_LFU_one

connect_audio:
	mov A, [lfu_regs + 1]
	ori A, 0b010000
	! SPK  01 bit 4    rx audio connect
	jr 1f
disconnect_audio:
	mov A, [lfu_regs + 1]
	ani A, ~0b010000
1:
	mov [lfu_regs + 1], A

	jmp update_LFU_one

update_LFU:
	mov A, [lfu_regs + 0]
	call update_LFU_one

	mov A, [lfu_regs + 1]
	call update_LFU_one

	mov A, [lfu_regs + 2]
	call update_LFU_one

	mov A, [lfu_regs + 3]
	call update_LFU_one
	ret

update_LFU_one:
	call 1f ; call 1f; call 1f; call 1f
	call 1f ; call 1f; call 1f; call 1f
	ori PA, LFUSTB
	nop
	nop
	ani PA, ~LFUSTB    ! end pulse
	ret
1:
	sllc A
	?ani PA, ~SDA
	skn CY
	?ori PA, SDA
	nop
	nop
	ori PA, SCL      ! rising edge seems the active one
	nop
	nop
	ani PA, ~SCL
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  CPU configuration

cpu_init:

	mvi PA, DTC | DATA   ! off: EXTA, CRM, LFUSTB, TSLG, SDA, SCL
	mvi A, DTC | DATA
	mov MA, A            ! inputs 1 (DTC and DATA left as inputs, unused)


	mvi PB, TAON         ! off: EEOFF, TSON, TAON, RSEN, TSEN, SD68
	mvi A, 0
	mov MB, A            ! inputs 1 (all outputs)


	mvi PC, 0x20 | DADIS | 0x02   ! off: PWROFF, WDCLR, PAGE, I2DA(our /PTT)
	mvi A, 0x23                   ! CI,RXD,TXD special
	mov MCC, A
	mvi A, 0x20 | I2DA | 0x02     ! magics for CI and RXD (I2DA is our /PTT)
	mov MC, A            ! inputs 1


	lxi HL, ad_regs
	shld [ad_ptr]

	mvi ANM, 0x00  ! scan mode, faster xtal, first group 0..3


	mvi TMM, 0x20  ! TMR0 run from f/12 into F/F, TMR1 run from f/384
	mvi A, 3
	mov TM0, A     ! 921.6 kHz, to generate serial 9600 bd for MBUS
	mvi A, 0xFF
	mov TM1, A     ! to generate 112 Hz systick (will use like 100 Hz)


	mvi A, 0x5E
	mov SML, A     ! 1stop, odd parity, 8bits, x16 clock
	mvi A, 0
	mov SMH, A     ! flush
	mvi A, 0x0C
	mov SMH, A     ! rx enable, tx enable, internal TO clock

	ori PC, WDCLR
	
	skit INTFST    ! flush tx
	?nop
	skit INTFSR    ! flush rx
	?nop
	skit ER        ! flush rx
	?nop
	mov A, RXB
	mov A, RXB
	mov A, RXB
	skit INTFST    ! flush tx
	?nop
	skit INTFSR    ! flush rx
	?nop
	skit ER        ! flush rx
	?nop

	mvi A, 0
	mov EOM, A     ! not interested at PWM capabilities

	mvi A, 0x08
	mov ETMM, A    ! clear ECNT at CI falling edge, internal f/12 clock
	lxi EA, 1843
	dmov ETM0, EA  ! 921.6 kHz / ETM0 = 500 Hz, about 20 mbus chars.

	ani PC, ~WDCLR

	ret

enable_ints:

	ani MKL, ~0x24 ! INTE0, INTT1
	ani MKH, ~0x07 ! INTST, INTSR, INTAD

	skit INTFT1
	?nop
	skit INTFE0
	?nop
	skit INTFST
	?nop
	skit INTFSR
	?nop
	skit INTFAD
	?nop

	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Audio stuff etc
!

vol_mute:
	mvi A, 0
	mov [volume], A
	jmp vol_set

vol_inc:
	mov A, [volume]
	adi A, 1
	lti A, 9
	?mvi A, 9
	mov [volume], A
	jmp vol_set

vol_dec:
	mov A, [volume]
	sui A, 1
	aci A, 0
	lti A, 9
	?mvi A, 9
	mov [volume], A
	jmp vol_set

vol_set:
	call redraw
	jmp mbus_sendvol

pwr_inc:
	mov A, [cfg_txpwr]
	adi A, 1
	lti A, 100
	?mvi A, 100
	mov [cfg_txpwr], A
	call DAC_update
	jmp redraw

pwr_dec:
	mov A, [cfg_txpwr]
	sui A, 1
	aci A, 0
	lti A, 100
	?mvi A, 100
	mov [cfg_txpwr], A
	call DAC_update
	jmp redraw

!----------------------------------------------------------------------
!----------------------------------------------------------------------

redraw:
	mov A, [menu_active]
	eqi A, 0
	?jmp draw_menu

	call draw_top_row
	jmp draw_kbd_buffer

! Something like
!
! "??? SQ V"
! "D 434775"

draw_top_row:
	lxi HL, prt_buffer

	mov A, [mem_idx]
	lti A, 100
	?jre 2f
	mov A, [mem_name]
	nei A, 0
	?jre 1f
	stax [HL]+
	mov A, [mem_name + 1]
	nei A, 0
	?mvi A, ' '
	stax [HL]+
	mov A, [mem_name + 2]
	nei A, 0
	?mvi A, ' '
	stax [HL]+
	jre 3f
1:
	mvi A, 'M'
	stax [HL]+
	mov A, [mem_idx]
	lxi EA, 0
	mov EAL, A
	mvi B, 10
	div B
	mov A, EAL
	adi A, '0'
	stax [HL]+
	mov A, B
	adi A, '0'
	stax [HL]+
	jr 3f
2:
	mvi A, ' '
	stax [HL]+
	stax [HL]+
	stax [HL]+
3:
	mvi A, ' '
	stax [HL]+

	mov A, [cfg_sqlevel]
	lti A, 100
	?mvi A, 99
	lxi EA, 0
	mov EAL, A
	mvi B, 10
	div B
	mov A, EAL
	adi A, '0'
	eqiw LO(sq_forced), 0
	?mvi A, 'S'
	stax [HL]+
	mov A, B
	adi A, '0'
	eqiw LO(sq_forced), 0
	?mvi A, 'Q'
	stax [HL]+

	mvi A, ' '
	stax [HL]+

	mov A, [volume]
	adi A, '0'
	stax [HL]+

	mvi C, 8
	lxi HL, prt_buffer
	jmp mbus_send_upper

draw_bottom_row:
	neiw LO(scan_state), STEPPING
	?jmp draw_scan_mode

	jmp draw_currfreq

draw_scan_mode:
	lxi HL, prt_buffer
	mvi A, 's'
	stax [HL]+
	mvi A, 'c'
	stax [HL]+
	mvi A, 'a'
	stax [HL]+
	mvi A, 'n'
	stax [HL]+             ! left "SCAN    "

	lxi HL, prt_buffer + 7
	mov B, [scan_mode]
	mvi A, '4'
	offi B, 0b1000
	?stax [HL]-
	mvi A, '3'
	offi B, 0b100
	?stax [HL]-
	mvi A, '2'
	offi B, 0b10
	?stax [HL]-
	mvi A, '1'
	offi B, 0b1
	?stax [HL]-

	mvi A, ' '
	lti L, LO(prt_buffer + 4)
	?stax [HL]-
	lti L, LO(prt_buffer + 4)
	?stax [HL]-
	lti L, LO(prt_buffer + 4)
	?stax [HL]-

	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_currfreq:
	lxi HL, rx_freq
	eqiw LO(tx_on), 0
	?lxi HL, tx_freq

	ldeax [HL]
	ldax [HL+2]
	mov B, A
	lxi HL, prt_buffer
	call i2buf
	mov A, [duplex_state]
	nei A, 0
	?jr 1f
	nei A, 1
	?mvi A, 'D'
	nei A, 2
	?mvi A, 'R'
	nei A, 3
	?mvi A, 'X'
	gti A, ' '
	?mvi A, '?'
	mov [prt_buffer + 0], A
1:
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_kbd_buffer:
	mov C, [kbd_index]
	nei C, 0
	?jmp draw_bottom_row    ! No value under edit. Show default bottom row

	lxi HL, kbd_buffer
	lxi DE, prt_buffer
	jr 2f
1:
	ldax [HL]+
	stax [DE]+
2:
	dcr C
	?jr 1b

	mov B, [alpha_box]
	nei B, 0
	?mvi B, ' '
	mvi C, 8
	mov A, [kbd_index]
	sub C, A
	jr 2f
1:
	mov A, B
	stax [DE]+
	mvi B, ' '
2:
	dcr C
	?jr 1b

	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

! Keep B

format_EA:
	lxi HL, prt_buffer + 5
	mvi C, 4
1:
	dcx HL
	mvi A, 10
	div A
	adi A, '0'
	stax [HL]
	dcr C
	?jr 1b

	mvi C, 3 ! blank out at max 4 leading zeroes
1:
	ldax [HL]
	eqi A, '0'   ! leading zero.
	?jr 1f
	mvi A, ' '
	stax [HL]+
	dcr C
	?jr 1b       ! 4 times max.
1:
	ret

alpha_off:
	push VA
	mov A, [kbd_flags]
	ani A, ~ALPHA
	mov [kbd_flags], A ! clear alpha state

	call mbus_update_lights
	pop VA
	ret

fcn_off:
	push VA
	mvi A, 0
	mov [timer_fcn], A
	mov A, [kbd_flags]
	ani A, ~SHIFT
	mov [kbd_flags], A ! clear shifted state

	call mbus_update_lights
	pop VA
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
!
!  New keyboard press in A, B nz if typematic
!
got_key:
	mov C, [curr_chr]
	mov [prev_chr], C
	mov [curr_chr], A

	mov C, [timer_kbd_idle]
	mviw LO(timer_kbd_idle), 0

	eqiw LO(timer_fcn), 0
	?mviw LO(timer_fcn), 15        ! bump up if running

	nei A, 'Q'
	?jmp do_quit
	nei A, 'P'
	?jmp do_ptt_button

	nei A, '+'
	?jmp do_plus
	nei A, '-'
	?jmp do_minus

	! other input ignored during xmit XXX

	eqiw LO(tx_on), 0
	?ret

	nei A, 'M'
	?jmp do_mute

	nei A, 'C'
	?jmp do_clear

	nei A, 'F'
	?jmp do_fcn
	nei A, 'A'
	?jmp do_r_alpha

	nei A, '?'
	?jmp do_menu_mft
	nei A, 'O'
	?jmp do_ok_lock
	nei A, 'N'
	?jmp do_next_prev
	nei A, 'R'
	?jmp do_rcl_sto

	nei A, '#'
	?jmp do_enter
	nei A, '*'
	?jmp do_star

	nei A, 'E'
	?jmp do_handset
	nei A, 'H'
	?jmp do_hf

	call scan_stop

	! all that is left are the digits

	offiw LO(kbd_flags), ALPHA
	?jmp alpha_input             ! ALPHA was not off, go.

chr_input:                 ! re-entry for specials as regulars

	mov B, [kbd_index]
	lti B, 8
	?ret

	lxi HL, kbd_buffer
	stax [HL+B]
	adi B, 1
	mov [kbd_index], B

	eqiw LO(menu_active), 0
	?jmp menu_input       ! Maybe it will want to touch the buffer

	jmp draw_kbd_buffer

alpha_star_tab: .ascii "*/?,.+`~!@#$%^&()_={}\\|;:'\"<>"

alpha_tab:      .ascii "[\\]0ABC1DEF2GHI3JKL4MNO5PQR6STU7VWX8YZ-9"

alpha_input_proloque:

	mov B, [kbd_index]
	nei B, 0
	?mviw LO(alpha_idx), 0 ! first chr, rewind ABC to 'A'
	lti C, 150
	?mviw LO(alpha_idx), 0 ! second of idle, rewind ABC to 'A'
	eqaw LO(prev_chr)
	?mviw LO(alpha_idx), 0 ! different key

	eqaw LO(prev_chr)
	?jr 1f        ! different key
	nei B, 0
	?jr 1f        ! no character
	lti C, 150
	?jr 1f        ! interval over 1 sec
	sui B, 1               ! rewind over the changing character
1:
	lti B, 8
	?mvi B, 8 - 1   ! last chr cell is problematic....

	ret

alpha_star_input:
	call alpha_input_proloque ! fetches B, amongst other fluff

	mov C, [alpha_idx]
	lti C, SIZE(alpha_star_tab)
	?mvi C, 0
	mov A, C                     ! index for picking this chr
	adi C, 1
	lti C, SIZE(alpha_star_tab)
	?mvi C, 0
	mov [alpha_idx], C           ! until next time, maybe

	lxi HL, alpha_star_tab
	ldax [HL+A]                ! map into chr

	jmp alpha_input_epiloque  ! uses the B, hrmph huh.

alpha_input:
	call alpha_input_proloque ! get B, also.

	mov C, [alpha_idx]
	lti C, 4
	?mvi C, 0

	lxi HL, alpha_tab
	sui A, '0'
	sll A
	sll A ! *= 4
	add A, C
	ldax [HL+A]

	adi C, 1
	lti C, 4
	?mvi C, 0
	mov [alpha_idx], C

	! FALLTHRU

alpha_input_epiloque:
	lxi HL, kbd_buffer
	stax [HL+B]
	adi B, 1
	lti B, 8
	?mvi B, 8
	mov [kbd_index], B

	jmp draw_kbd_buffer

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  SCANNER
!

scan_stop:
	push VA
	mvi A, 0
	staw LO(timer_step)
	staw LO(timer_scan)
	staw LO(timer_pers)
	neiw LO(scan_state), 0
	?jr 1f
	staw LO(scan_state)
	push BC
	push DE
	push HL
	push EA
	call mbus_update_lights
	pop EA
	pop HL
	pop DE
	pop BC
1:
	pop VA
	ret

scan_start:
	lxi HL, kbd_buffer
	mov C, [kbd_index]
	mviw LO(kbd_index), 0

	mvi B, 0
	jr 2f
1:
	ldax [HL]+
	nei A, '1'
	?ori B, 1
	nei A, '2'
	?ori B, 2
	nei A, '3'
	?ori B, 4
	nei A, '4'
	?ori B, 8
2:
	dcr C
	?jr 1b
	mov A, B

	ani A, 0x0F
	eqi A, 0
	?staw LO(scan_mode)
	neiw LO(scan_mode), 0
	?mviw LO(scan_mode), 1

	call scan_step_now
	jmp mbus_update_lights         ! nz scan_state will light HF

scan_step_now:
	ldaw LO(scan_state)
	push VA                        ! were we already stepping, or ?
	mviw LO(scan_state), STEPPING
	mvi A, 0
	staw LO(timer_scan)
	staw LO(timer_pers)

	call scan_next_one
	call start_step_timer        ! starts timer_step

	pop VA
	eqi A, STEPPING
	?call redraw                 ! change into stepping.
	ret

scan_next_one:

	lxi HL, rx_freq
	lxi DE, cfg_sc2_low          ! below this = currently sc1
	call skip_if_freq_below
	jre 2f

	oniw LO(scan_mode), 1
	?jre 2f                     ! not doing onesies

	mvi C, 1
	lxi HL, rx_freq
	call step_channels_up

	lxi HL, rx_freq
	lxi DE, cfg_sc1_high         ! above this = step over to sc2_low
	call skip_if_freq_above
	jr 1f                        ! skipped if above higher limit
	lxi HL, cfg_sc2_low
	oniw LO(scan_mode), 2
	?lxi HL, cfg_sc1_low         ! but we were not scanning twosies
	lxi DE, rx_freq
	call copy_long
1:
	call leave_memories
	call set_duplex_wrt_freq
	call freq_changed
	ret
2:
	mvi C, 1
	lxi HL, rx_freq
	call step_channels_up

	lxi HL, rx_freq
	lxi DE, cfg_sc2_high         ! above this = rewind to sc1_low
	call skip_if_freq_above
	jr 1f                        ! skipped if above higher limit
	lxi HL, cfg_sc1_low
	oniw LO(scan_mode), 1
	?lxi HL, cfg_sc2_low         ! but we were not scanning onesies
	lxi DE, rx_freq
	call copy_long
1:
	call leave_memories
	call set_duplex_wrt_freq
	call freq_changed
	ret

start_step_timer:

	lxi HL, cfg_step_rate
	ldeax [HL]
	mvi B, 10
	div B
	mov A, EAL
	lti B, 5
	?adi A, 1
	gti A, 1
	?mvi A, 1
	staw LO(timer_step)
	ret

check_scan:
	neiw LO(scan_state), 0
	?ret                         ! not scanning
	neiw LO(timer_step), 1
	?jr 1f
	neiw LO(timer_scan), 1
	?jr 1f
	neiw LO(timer_pers), 1
	?jr 1f
	ret                          ! timers still running or not running
1:
	eqiw LO(scan_state), STEPPING
	?jmp scan_step_now           ! any timer during other than STEPPING

	mov A, [rssi]
	mov B, [cfg_sqlevel]
	lta A, B                     ! rssi < sql.
	?jmp scan_promising_one      ! ?Not. stay here for a while.

	jmp scan_step_now            ! no sig. next.

scan_promising_one:
	mviw LO(scan_state), WAITING
	mviw LO(timer_step), 0
	mviw LO(timer_scan), 2       ! walk away soon if nothing happens.

	call squelch                 ! and see what happens
	call redraw            
	ret

scan_squelch_closing:
	mviw LO(scan_state), WAITING
	mviw LO(timer_step), 0
	mov A, [cfg_scan_wait]
	mov [timer_scan], A
	ret

scan_squelch_opening:
	mviw LO(scan_state), LISTENING
	mviw LO(timer_step), 0
	mov A, [cfg_scan_listen]
	mov [timer_scan], A
	mov A, [cfg_scan_pers]
	mov [timer_pers], A
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  MAIN
!
main:

	mvi A, 200
	call pause       ! twiddle here around 2 seconds

	! Go on.

	call mbus_hello
	call handset_init

	call menu_init
	call synth_init
	call i8253_init
	call LFU_init
	call DAC_init
	call modem_init
	call freq_changed
	call disconnect_audio

	mvi A, 200
	call pause     ! twiddle again

1:
	oni PC, I2DA
	?jr 1b         ! dual purpose, time to see the version & avoid stuck ptt

	call redraw
	call mbus_sendsig
	call mbus_sendvol
	call squelch_now_closed

	eqiw LO(scan_state), 0
	?call scan_start

mainloop:
	call check_warnings

	call mbus_process

	call check_ptt_pin

	eqiw LO(tx_on), 0
	?jmp txmain

	! only during receive

	call read_rssi           ! before below ones use [rssi]

	call squelch
	call check_rssi_display
	call check_dynamic_menu
	call check_scan
	call check_serv
	call timeout_fcn

	jmp mainloop

	! only during tx

txmain:

	call check_stuck_tx
	call read_pfb
	call check_pfb_display
	call check_dynamic_menu

	jmp mainloop

check_stuck_tx:
	mov A, [timer_txon]
	eqi A, 0
	?ret

	call stop_xmit_stealth

	mvi A, 1
	mov [timer_txon], A   ! yell again after in a minute

	call warning; .asciz "STUCK TX" ! dont skip this
	ret

check_warnings:
	eqiw LO(timer_kbd_idle), 255
	?ret

	call check_temperature
	call check_voltage
	ret

check_voltage:
	mov B, [cfg_volt_warn]		! OH3NWQ A->B
	call read_BATT			! OH3NWQ added - puts V*10 to A
	!mov A, [ad_BATT]		! OH3NWQ deleted
	!call map_percents_to_byte	! OH3NWQ deleted
	lta A, B			! OH3NWQ - had to switch A and B
	?jmp ok_voltage
	mov A, [delay_batt]
	adi A, 1
	mov [delay_batt], A
	eqi A, 0
	?ret
	offiw LO(pending_notices), 1
	?ret
	oriw LO(pending_notices), 1
	call warning; .asciz "LOW VOLTAGE" ! dont skip this
	ret
ok_voltage:
	mvi A, 0
	mov [delay_batt], A
	ret

check_temperature:
	mov A, [cfg_temp_warn]
	call map_percents_to_byte
	mov B, [ad_TEMP]
	lta A, B
	?jmp ok_temperature
	mov A, [delay_temp]
	adi A, 1
	mov [delay_temp], A
	eqi A, 0
	?ret
	offiw LO(pending_notices), 2
	?ret
	oriw LO(pending_notices), 2
	call warning; .asciz "OVERTEMPERATURE"
	ret
ok_temperature:
	mvi A, 0
	mov [delay_temp], A
	ret

!  Notice To The Tenant...

1: .ascii " R R R RRRR R "  ! VE

warning:
	lxi HL, 1b
	mvi C, SIZE(1b)
	call mbus_send_tones

notice:
	pop HL
	push HL
	pop DE
	mvi C, -1             ! Count DeMonet
1:
	adi C, 1
	ldax [DE]+
	eqi A, 0
	?jr 1b
	push DE               ! Return To Sender
	jmp mbus_send_lower

babble:
	pop EA
	lxi HL, 16
	dadd EA, HL
	push EA        ! ra
	lxi HL, 8
	dsub EA, HL
	push EA        ! lower
	dsub EA, HL
	push EA        ! upper
	pop HL
	mvi C, 8
	call mbus_send_upper
	pop HL
	mvi C, 8
	jmp mbus_send_lower

pause:
	staw LO(timer_ticks)
1:
	eqiw LO(timer_ticks), 0
	?jr 1b
	ret

timeout_fcn:
	oniw LO(kbd_flags), SHIFT
	?ret
	eqiw LO(timer_fcn), 0
	?ret
	jmp fcn_off

!! we have 2 external sources for xmission, "ptt" button
!! and /PTT (originally I2DA). Also signalling can want xmission,

check_ptt_pin:
	oni PC, I2DA
	?oriw LO(tx_on), 2
	offi PC, I2DA
	?aniw LO(tx_on), ~2

	jmp check_tx_state

check_tx_state:
	ldaw LO(tx_on)
	slrc A                ! CY gets the current TX status, "want" bits in A
	?jr 1f                ! CY skips this
	eqi A, 0              ! tx is on. A is zero (no "want")
	?ret                  ! Oh, is and should be tx.
	jmp stop_xmit
1:
	nei A, 0              ! tx is off. A is nonzero (someone "wants")
	?ret                  ! Oh, is not and should not tx.
	call scan_stop
	jmp start_xmit

check_serv:
	eqiw LO(sq_changed), 0
	?call mbus_sendsig
	ret

!----------------------------------------------------------------------
squelch:
	neiw LO(scan_state), STEPPING
	?ret                           ! frozen squelch during stepping scanner
	mov A, [sqopen]
	eqi A, 0
	?jmp squelch_is_open
	jmp squelch_is_closed

squelch_is_closed:
	mov A, [cfg_sqlevel]
	mov B, [cfg_sqhyst]
	slr B               ! halve
	add A, B            ! use level + 1/2 hyst
	skn CY
	?mvi A, 0xFF
	mov B, [rssi]
	lta A, B
	?jmp 1f             ! ?Not. below lower limit. definitely closed.
	mov A, [timer_sq]
	nei A, 1
	?jmp squelch_now_open ! at 1, timeout
	eqi A, 0
	?ret                ! already timing.
	jmp start_sqdelay
1:
	mvi A, 0
	mov [timer_sq], A   ! stay closed.
	ret

start_sqdelay:
	lxi HL, cfg_sqdelay
	ldeax [HL]
	mvi A, 10
	div A
	mov A, EAL
	nei A, 0
	?jmp squelch_now_open ! no open delay
	mov [timer_sq], A
	ret

start_sqtail:
	lxi HL, cfg_sqtail
	ldeax [HL]
	mvi A, 10
	div A
	mov A, EAL
	nei A, 0
	?jmp squelch_now_closed ! no open delay
	mov [timer_sq], A
	ret

squelch_is_open:
	mov A, [cfg_sqlevel]
	mov B, [cfg_sqhyst]
	slr B               ! halve
	sub A, B            ! use level - 1/2 hyst
	skn CY
	?mvi A, 0
	mov B, [rssi]
	gta A, B
	?jmp 1f             ! ?Not. above upper limit. definitely open.
	mov A, [timer_sq]
	nei A, 1
	?jmp squelch_now_closed ! at 1, timeout
	eqi A, 0
	?ret                ! already timing.
	jmp start_sqtail
1:
	mvi A, 0
	mov [timer_sq], A   ! stay open.
	ret

squelch_now_closed:
	mvi A, 0
	mov [sqopen], A
	mvi A, 0
	mov [timer_sq], A
	mvi A, 1
	mov [sq_changed], A

	oniw LO(sq_forced), 1
	?call disconnect_audio              ! ?Not. close audio

	neiw LO(scan_state), LISTENING
	?call scan_squelch_closing          ! LISTENING and squelch closed
	ret

squelch_now_open:
	mvi A, 1
	mov [sqopen], A
	mvi A, 0
	mov [timer_sq], A
	mvi A, 1
	mov [sq_changed], A

	call connect_audio

	neiw LO(scan_state), WAITING        ! WAITING and squelch opened
	?call scan_squelch_opening
	ret

sq_override:
	mov A, [sq_forced]
	xri A, 1
	mov [sq_forced], A
	oniw LO(sq_forced), 1
	?call squelch_now_closed
	offiw LO(sq_forced), 1
	?call connect_audio
	jmp redraw

sq_inc:
	mviw LO(sq_forced), 0
	mov A, [cfg_sqlevel]
	lti A, 99
	?mvi A, 99
	adi A, 1
	mov [cfg_sqlevel], A
	jmp redraw

sq_dec:
	mviw LO(sq_forced), 0
	mov A, [cfg_sqlevel]
	lti A, 100
	?mvi A, 100
	sui A, 1
	aci A, 0
	mov [cfg_sqlevel], A
	jmp redraw

	!  Either
	!   currently we have NO audio, but user suggests
	!   that squelch ought to be OPEN.
	!  Or
	!   currently we HAVE audio, but user suggests
	!   that squelch ought to be CLOSED.
sq_auto:
	mviw LO(sq_forced), 0
	mov A, [sig_peak]
	mov B, [cfg_sqhyst]
	sll B
	eqiw LO(sqopen), 0
	?jr 1f
	sub A, B         ! sq level = peak rssi - 2 * hyst, when sq closed
	skn CY
	?mvi A, 0
	jr 2f
1:
	add A, B        ! sq level = peak rssi + 2 * hyst, when sq open
	skn CY
	?mvi A, 0xFF
2:
	mov [cfg_sqlevel], A
	jmp redraw

!----------------------------------------------------------------------
check_rssi_display:
	mov A, [rssi]
	mov B, [sig_peak]
	nea A, B
	?ret               ! same.
	lta A, B
	?jmp new_rssi      ! rssi has rised
	eqiw LO(timer_sig), 0
	?ret               ! still timing last peak
	jmp new_rssi

new_rssi:
	mov [sig_peak], A
	call mbus_sendsig
	mvi A, 200
	mov [timer_sig], A
	ret

read_rssi:
	mov A, [rssi]
	mov [rssi_prev], A
	mov A, [ad_RSSI]
	sui A, 30           ! XXX discard 30 steps from bottom
	skn CY
	?mvi A, 0
	mvi B, 100
	mul B
	mvi A, (255 - 30 - 30) ! XXX also discard 30 steps from top
	div A
	mov A, EAL
	lti A, 99
	?mvi A, 99
	mov [rssi], A
	ret

read_pfb:
	mov A, [pfb]
	mov [pfb_prev], A
	mov A, [ad_PFB]
	mvi B, 100
	mul B
	mvi A, (255 - 0 - 0) ! XXX floor and ceil
	div A
	mov A, EAL
	lti A, 99
	?mvi A, 99
	mov [pfb], A
	ret

check_pfb_display:
	mov A, [pfb]
	mov B, [sig_peak]
	nea A, B
	?ret               ! same.
	lta A, B
	?jmp new_pfb      ! pfb has rised
	eqiw LO(timer_sig), 0
	?ret               ! still timing last peak
	jmp new_pfb

new_pfb:
	mov [sig_peak], A
	call mbus_sendsig
	mvi A, 100
	mov [timer_sig], A
	ret

!----------------------------------------------------------------------

check_dynamic_menu:
	neiw LO(menu_active), 0
	?ret
	lhld [menu_ptr]
	ldax [HL+offset_type]
	eqi A, CFG_DYN
	?ret
	eqiw LO(timer_ticks), 0
	?ret
	call draw_menu_lower     ! CFG_DYN need constant update
	mviw LO(timer_ticks), 100
	ret

canada:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.asciz "CANADA !"

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  SMALL UTILITIES
!

map_chr_to_hex:
	gti A, '0' - 1         ! at or above ascii 0
	?ret
	lti A, 'a'             ! 0..9 or A..Z
	?jr 1f
	lti A, 'A'             ! 0..9
	?jr 2f
	sui A, '0'             ! '0' to 0 etc
	ret
1:
	sui A, 'a' - 10        ! 'a' to 0xA etc
	ret
2:
	sui A, 'A' - 10        ! 'A' to 0xA etc
	ret

str2i:
	mvi B, 0
1:
	ldax [HL+B]
	nei A, 0
	?jr 1f
	adi B, 1
	gti B, 7
	?jr 1b
1:
	mov A, B
	mov C, A
	jmp buf2i

map_idx_to_txtone:
	lxi HL, cfg_txtone1
	nei A, 1
	?rets
	lxi HL, cfg_txtone2
	nei A, 2
	?rets
	lxi HL, cfg_txtone3
	nei A, 3
	?rets
	lxi HL, cfg_txtone4
	nei A, 4
	?rets
	lxi HL, cfg_txtone5
	nei A, 5
	?rets
	lxi HL, cfg_txtone6
	nei A, 6
	?rets
	lxi HL, cfg_txtone7
	nei A, 7
	?rets
	lxi HL, cfg_txtone8
	nei A, 8
	?rets
	ret

! A contains 0..100, return A 0..255

map_percents_to_byte:
	push HL
	lxi HL, 1f
	lti A, 100
	?mvi A, 100
	ldax [HL+A]
	pop HL
	ret
1:
	.byte   0,   3,   5,   8,  10,  13,  15,  18,  20,  23
	.byte  26,  28,  31,  33,  36,  38,  41,  43,  46,  48
	.byte  51,  54,  56,  59,  61,  64,  66,  69,  71,  74
	.byte  76,  79,  82,  84,  87,  89,  92,  94,  97,  99
	.byte 102, 105, 107, 110, 112, 115, 117, 120, 122, 125
	.byte 127, 130, 133, 135, 138, 140, 143, 145, 148, 150
	.byte 153, 156, 158, 161, 163, 166, 168, 171, 173, 176
	.byte 178, 181, 184, 186, 189, 191, 194, 196, 199, 201
	.byte 204, 207, 209, 212, 214, 217, 219, 222, 224, 227
	.byte 229, 232, 235, 237, 240, 242, 245, 247, 250, 252
	.byte 255


map_byte_to_voltage:
	push HL
	lxi HL, 1f
	ldax [HL+A]
	pop HL
	ret
1:
	.byte	2	!	0
	.byte	3	!	1
	.byte	3	!	2
	.byte	4	!	3
	.byte	5	!	4
	.byte	6	!	5
	.byte	6	!	6
	.byte	7	!	7
	.byte	8	!	8
	.byte	8	!	9
	.byte	9	!	10
	.byte	10	!	11
	.byte	10	!	12
	.byte	11	!	13
	.byte	12	!	14
	.byte	12	!	15
	.byte	13	!	16
	.byte	14	!	17
	.byte	14	!	18
	.byte	15	!	19
	.byte	16	!	20
	.byte	17	!	21
	.byte	17	!	22
	.byte	18	!	23
	.byte	19	!	24
	.byte	19	!	25
	.byte	20	!	26
	.byte	21	!	27
	.byte	21	!	28
	.byte	22	!	29
	.byte	23	!	30
	.byte	23	!	31
	.byte	24	!	32
	.byte	25	!	33
	.byte	26	!	34
	.byte	26	!	35
	.byte	27	!	36
	.byte	28	!	37
	.byte	28	!	38
	.byte	29	!	39
	.byte	30	!	40
	.byte	30	!	41
	.byte	31	!	42
	.byte	32	!	43
	.byte	32	!	44
	.byte	33	!	45
	.byte	34	!	46
	.byte	34	!	47
	.byte	35	!	48
	.byte	36	!	49
	.byte	37	!	50
	.byte	37	!	51
	.byte	38	!	52
	.byte	39	!	53
	.byte	39	!	54
	.byte	40	!	55
	.byte	41	!	56
	.byte	41	!	57
	.byte	42	!	58
	.byte	43	!	59
	.byte	43	!	60
	.byte	44	!	61
	.byte	45	!	62
	.byte	46	!	63
	.byte	46	!	64
	.byte	47	!	65
	.byte	48	!	66
	.byte	48	!	67
	.byte	49	!	68
	.byte	50	!	69
	.byte	50	!	70
	.byte	51	!	71
	.byte	52	!	72
	.byte	52	!	73
	.byte	53	!	74
	.byte	54	!	75
	.byte	54	!	76
	.byte	55	!	77
	.byte	56	!	78
	.byte	57	!	79
	.byte	57	!	80
	.byte	58	!	81
	.byte	59	!	82
	.byte	59	!	83
	.byte	60	!	84
	.byte	61	!	85
	.byte	61	!	86
	.byte	62	!	87
	.byte	63	!	88
	.byte	63	!	89
	.byte	64	!	90
	.byte	65	!	91
	.byte	66	!	92
	.byte	66	!	93
	.byte	67	!	94
	.byte	68	!	95
	.byte	68	!	96
	.byte	69	!	97
	.byte	70	!	98
	.byte	70	!	99
	.byte	71	!	100
	.byte	72	!	101
	.byte	72	!	102
	.byte	73	!	103
	.byte	74	!	104
	.byte	74	!	105
	.byte	75	!	106
	.byte	76	!	107
	.byte	77	!	108
	.byte	77	!	109
	.byte	78	!	110
	.byte	79	!	111
	.byte	79	!	112
	.byte	80	!	113
	.byte	81	!	114
	.byte	81	!	115
	.byte	82	!	116
	.byte	83	!	117
	.byte	83	!	118
	.byte	84	!	119
	.byte	85	!	120
	.byte	86	!	121
	.byte	86	!	122
	.byte	87	!	123
	.byte	88	!	124
	.byte	88	!	125
	.byte	89	!	126
	.byte	90	!	127
	.byte	90	!	128
	.byte	91	!	129
	.byte	92	!	130
	.byte	92	!	131
	.byte	93	!	132
	.byte	94	!	133
	.byte	94	!	134
	.byte	95	!	135
	.byte	96	!	136
	.byte	97	!	137
	.byte	97	!	138
	.byte	98	!	139
	.byte	99	!	140
	.byte	99	!	141
	.byte	100	!	142
	.byte	101	!	143
	.byte	101	!	144
	.byte	102	!	145
	.byte	103	!	146
	.byte	103	!	147
	.byte	104	!	148
	.byte	105	!	149
	.byte	106	!	150
	.byte	106	!	151
	.byte	107	!	152
	.byte	108	!	153
	.byte	108	!	154
	.byte	109	!	155
	.byte	110	!	156
	.byte	110	!	157
	.byte	111	!	158
	.byte	112	!	159
	.byte	112	!	160
	.byte	113	!	161
	.byte	114	!	162
	.byte	114	!	163
	.byte	115	!	164
	.byte	116	!	165
	.byte	117	!	166
	.byte	117	!	167
	.byte	118	!	168
	.byte	119	!	169
	.byte	119	!	170
	.byte	120	!	171
	.byte	121	!	172
	.byte	121	!	173
	.byte	122	!	174
	.byte	123	!	175
	.byte	123	!	176
	.byte	124	!	177
	.byte	125	!	178
	.byte	126	!	179
	.byte	126	!	180
	.byte	127	!	181
	.byte	128	!	182
	.byte	128	!	183
	.byte	129	!	184
	.byte	130	!	185
	.byte	130	!	186
	.byte	131	!	187
	.byte	132	!	188
	.byte	132	!	189
	.byte	133	!	190
	.byte	134	!	191
	.byte	134	!	192
	.byte	135	!	193
	.byte	136	!	194
	.byte	137	!	195
	.byte	137	!	196
	.byte	138	!	197
	.byte	139	!	198
	.byte	139	!	199
	.byte	140	!	200
	.byte	141	!	201
	.byte	141	!	202
	.byte	142	!	203
	.byte	143	!	204
	.byte	143	!	205
	.byte	144	!	206
	.byte	145	!	207
	.byte	146	!	208
	.byte	146	!	209
	.byte	147	!	210
	.byte	148	!	211
	.byte	148	!	212
	.byte	149	!	213
	.byte	150	!	214
	.byte	150	!	215
	.byte	151	!	216
	.byte	152	!	217
	.byte	152	!	218
	.byte	153	!	219
	.byte	154	!	220
	.byte	154	!	221
	.byte	155	!	222
	.byte	156	!	223
	.byte	157	!	224
	.byte	157	!	225
	.byte	158	!	226
	.byte	159	!	227
	.byte	159	!	228
	.byte	160	!	229
	.byte	161	!	230
	.byte	161	!	231
	.byte	162	!	232
	.byte	163	!	233
	.byte	163	!	234
	.byte	164	!	235
	.byte	165	!	236
	.byte	166	!	237
	.byte	166	!	238
	.byte	167	!	239
	.byte	168	!	240
	.byte	168	!	241
	.byte	169	!	242
	.byte	170	!	243
	.byte	170	!	244
	.byte	171	!	245
	.byte	172	!	246
	.byte	172	!	247
	.byte	173	!	248
	.byte	174	!	249
	.byte	174	!	250
	.byte	175	!	251
	.byte	176	!	252
	.byte	177	!	253
	.byte	177	!	254
	.byte	178	!	255
	
	



! For short number commands. Clear also the buffer.

get_the_number:
	mov C, [kbd_index]
	lxi HL, kbd_buffer
	call buf2i
	mvi A, 0
	mov [kbd_index], A
	mov A, EAL
	ret

!  Return 0 in BC without pending digits, else the number -1.
!  Buffer is also emptied.
!  used to multiply plain commands. (3 NEXT)

repeat_count:
	lxi BC, 0
	mov A, [kbd_index]
	nei A, 0
	?ret                  ! no digits, return 0
	mov C, A
	lxi HL, kbd_buffer
	call buf2i
	push EA
	pop BC                ! return number - 1
	eqi C, 0
	?sui C, 1
	mvi A, 0
	mov [kbd_index], A    ! zero out buffer
	ret

!  Divide frequency in [HL] (3 bytes) by B, e.g. freq / 25
!  Store result to [DE] (3 bytes), leave remainder in B

divide_long_by_B:
	ldeax [HL+1]      ! freq 2 MSBytes
	mov A, B          ! divisor
	div A
	steax [DE+1]      ! EAH result 2 MSBytes
	ldeax [HL]
	mov EAH, A        ! freq LSByte and remainder from above
	div B             ! leaves remainder in B
	mov A, EAL        ! result LSByte
	stax [DE]         ! into place
	ret

!  Multiply divisor in [HL] (3 bytes) by B, e.g. divisor * 25
!  Store result (e.g. frequency) into [DE] (3 bytes)

multiply_long_by_B:
	push BC
	ldax [HL+2]       ! [2] MSByte
	mul B
	push EA
	ldax [HL+1]       ! [1] middle byte
	mul B
	push EA
	ldax [HL]         ! [0] LSByte
	mul B
	steax [DE]        ! store result LSByte
	mov A, EAH
	pop EA            ! get 2nd *
	eadd EA, A        ! CY valid
	steax [DE+1]      ! store result middle byte
	mov A, EAH
	pop BC            ! get 1st *
	adc A, C          ! CY used
	stax [DE+2]       ! store result MSByte
	pop BC
	ret

! destination DE, HL+BC
add_longs:
	push BC
	ldax [HL]
	addx [BC]
	stax [DE]
	inx BC
	ldax [HL+1]
	adcx [BC]
	stax [DE+1]
	inx BC
	ldax [HL+2]
	adcx [BC]
	stax [DE+2]
	pop BC
	ret

! destination DE, HL-BC
subtract_longs:
	push BC
	ldax [HL]
	subx [BC]
	stax [DE]
	inx BC
	ldax [HL+1]
	sbbx [BC]
	stax [DE+1]
	inx BC
	ldax [HL+2]
	sbbx [BC]
	stax [DE+2]
	pop BC
	ret

! skip-return if freq is not zero (e.g. testing if setup freqs are set)

skip_if_not_empty_freq:
	ldax [HL]
	eqi A, 0
	?rets
	ldax [HL+1]
	eqi A, 0
	?rets
	ldax [HL+2]
	eqi A, 0
	?rets
	ret

skip_if_different_freqs:
	push DE
	ldax [HL]
	subx [DE]
	eqi A, 0
	?jr 1f
	inx DE
	ldax [HL+1]
	subx [DE]
	eqi A, 0
	?jr 1f
	inx DE
	ldax [HL+2]
	subx [DE]
1:
	pop DE
	eqi A, 0
	?rets          ! skips if freqs are different
	ret

! skip-return if long at [HL] is less than long at [DE] (HL-DE borrows)

skip_if_freq_below:
	push DE
	ldax [HL]
	subx [DE]
	inx DE
	ldax [HL+1]
	sbbx [DE]
	inx DE
	ldax [HL+2]
	sbbx [DE]
	pop DE
	sk CY
	?ret
	rets                 ! skip-return, freq is below

! skip-return if long at [HL] is greater than long at [DE] (DE-HL borrows)

skip_if_freq_above:
	push HL
	ldax [DE]
	subx [HL]
	inx HL
	ldax [DE+1]
	sbbx [HL]
	inx HL
	ldax [DE+2]
	sbbx [HL]
	pop HL
	sk CY
	?ret
	rets                 ! skip-return, freq is above

copy_long:
	ldeax [HL]
	steax [DE]
	ldax [HL+2]
	stax [DE+2]
	ret



! input in HL & C (kept), result to BEA,
! nondigits in buffer are not handled (funny results).
! leading blanks are skipped, thou.

buf2i:
	push BC
	push DE
	push HL
	mvi B, 0
	lxi EA, 0    ! collect here
1:
	nei C, 0
	?jr 1f
	ldax [HL]
	eqi A, ' '
	?jr 1f
	inx HL
	sui C, 1
	jr 1b
1:
	jmp 2f       ! start loop below, for 0 length input
1:
	dmov DE, EA
	mov A, B     ! copy BEA into ADE
	dadd EA, DE
	adc A, B     ! * 2 (in AEA)
	dadd EA, DE
	adc A, B     ! * 3
	dadd EA, DE
	adc A, B     ! * 4
	dadd EA, DE
	adc A, B     ! * 5
	dmov DE, EA
	mov B, A     ! copy AEA into BDE
	dadd EA, DE
	adc B, A     ! * 10 complete in BEA
	ldax [HL]+
	sui A, '0'
	eadd EA, A
	aci B, 0     ! ones added
2:
	dcr C
	?jre 1b
	mov A, B
	pop HL
	pop DE
	pop BC
	mov B, A     ! BEA has integer
	ret

! input in BEA
! output to [HL]...[HL+7]
! regs destroyed

i2buf:
	mvi A,  10000000 / 65536
	lxi DE, 10000000 % 65536
	call 1f
	adi A, '0'
	stax [HL+0]              ! 1_______ 0x67697f  0_______ 0x00ffff
	mvi A,  1000000 / 65536
	lxi DE, 1000000 % 65536
	call 1f
	adi A, '0'
	stax [HL+1]              ! 16______ 0x0bdbff  00______ 0x00ffff
	mvi A,  100000 / 65536
	lxi DE, 100000 % 65536
	call 1f
	adi A, '0'
	stax [HL+2]              ! 167_____ 0x012d9f  000_____ 0x00ffff
	mvi A,  10000 / 65536
	lxi DE, 10000 % 65536
	call 1f     
	adi A, '0'
	stax [HL+3]              ! 1677____ 0x001c2f  0006____ 0x00159f
	mvi A, 10
	div A
	adi A, '0'
	stax [HL+7]              ! 1677___5           0006___5
	mvi A, 10
	div A
	adi A, '0'
	stax [HL+6]              ! 1677__15           0006__35
	mvi A, 10
	div A
	adi A, '0'
	stax [HL+5]              ! 1677_215           0006_535
	mov A, EAL
	adi A, '0'
	stax [HL+4]              ! 16777215           00065535

	mvi C, 6
2:
	ldax [HL]
	eqi A, '0'
	?jr 2f
	mvi A, ' '
	stax [HL]+
	dcr C
	?jr 2b
2:
	ret
1:
	mvi C, -1
1:
	adi C, 1
	dsub EA, DE
	sbb B, A
	sk CY
	?jr 1b
	dadd EA, DE
	adc B, A
	mov A, C
	ret

! C has count of steps, [HL] has freq

step_channels_up:
	call align_freq
	call get_C_channels_span
	dmov DE, EA
	ldeax [HL]
	ldax [HL+2]
	dadd EA, DE
	aci A, 0
	steax [HL]
	stax [HL+2]
	ret

step_channels_down:
	call skip_if_aligned_freq
	sui C, 1
	call align_freq
	call get_C_channels_span
	dmov DE, EA
	ldeax [HL]
	ldax [HL+2]
	dsub EA, DE
	sbi A, 0
	steax [HL]
	stax [HL+2]
	ret

skip_if_aligned_freq:
	mov A, [cfg_chan_step]
	mvi B, 25
	nei A, 1
	?mvi B, 20
	nei A, 2
	?mvi B, 25        ! barf, 12.5 silliness
	nei A, 3
	?mvi B, 10
	lxi DE, scratch_freq
	call divide_long_by_B
	nei B, 0                    ! there was remainder.
	?rets                       ! no need to fixup steps, starting aligned
	mov A, [cfg_chan_step]
	eqi A, 2                    ! 12.5 index
	?ret
	eqi B, 12
	?ret
	rets                        ! aligned at 12.5

align_freq:
2:
	mov A, [cfg_chan_step]
	mvi B, 25
	nei A, 1
	?mvi B, 20
	nei A, 2
	?mvi B, 25        ! barf, 12.5 silliness
	nei A, 3
	?mvi B, 10
	lxi DE, scratch_freq
	call divide_long_by_B
	nei B, 0                    ! not aligned.
	?ret                        !
	eqi B, 12                   ! remainder 12
	?jr 1f
	mov A, [cfg_chan_step]
	eqi A, 2                    ! with 12.5 step
	?jr 1f
	ret                         ! aligned at 12.5
1:
	ldeax [HL]
	ldax [HL+2]
	mvi B, 1      ! i'm laughing too
	esub EA, B
	sbi A, 0
	steax [HL]
	stax [HL+2]
	jre 2b

! into EA kHz to add, max 255 * 25, 6375

get_C_channels_span:
	mov A, [cfg_chan_step]
	mvi B, 25
	nei A, 1
	?mvi B, 20
	nei A, 2
	?mvi B, 25        ! barf, 12.5 really
	nei A, 3
	?mvi B, 10
	mov A, C
	mul B
	mov A, [cfg_chan_step]
	nei A, 2
	?dslr EA        ! barf^2
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  CW beeper
!
!
! tabled bits 1=dit, 0=dash. right aligned into byte.
! unused bits contain first one 1, then zeroes (0b10000000 terminate).
!
! ______________________________________________  46 slots aka dit-times
! X XXX XXX X __X XXX __X XXX X __X X   X X X __ 
! P             A       R         I     S
! 46 slots / 5 chrs;  9.2  slots/chr.
! N chrs/min; N chrs / 60 sec
! 60 / ( 9.2 * N )  sec/slot
! 112 ticks/sec
! 730/N  ticks/slot

! Separate character, 3 dit-times of silence after last tone

cw_chr:
	eqi A, ' '
	?call cw_chr_1       ! *_---_
	call cw_pause        ! _
	call cw_pause        ! _
	ret

! sleep for one dit-time

cw_pause:
	lxi HL, cfg_cw_speed
	ldeax [HL]
	mov A, EAH
	eqi A, 0
	?lxi EA, 255        ! cannot go faster (also unreadable)
	mov A, EAL
	gti A, 40
	?mvi A, 40          ! be reasonable, we'd be here until next week
	lxi EA, 730         ! see above for maths. WPM into slept ticks
	div A
	mov A, EAL
	jmp pause

! play one cw character. No extra slot is appended, just the one silence.
! i.e. 2 slots per dit, 4 slots per dash.

cw_chr_1:               ! fill slots contained in chr
	push HL
	lxi HL, cw_tab
	ldax [HL+A]
	oni A, 0x7F         ! terminator 1-bit there ?
	?mvi A, 0b11001110  ! '?'
2:
	push VA
	call cw_tone_on
	pop VA
	sll A
	push VA
	skn CY               ! CY=0=dash
	?jr 1f
	call cw_pause
	call cw_pause
1:
	call cw_pause
	call cw_tone_off
	call cw_pause
	pop VA
	eqi A, 0x80         ! terminator shifted into place.
	?jr 2b
	pop HL
	ret                 ! done.

cw_tone_off:
	jmp i8253_tone_off

cw_tone_on:
	lxi HL, cfg_cw_pitch
	ldeax [HL]          ! Hz as configured in EA
	jmp i8253_tone_hz

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Key specific actions
!
!----------------------------------------------------------------------

do_quit:

	ani PB, ~(TXON | TSON | TAON)

	call disconnect_audio
	call mbus_handset_blank
	call babble; .ascii PROVERB

	mvi A, 100
	call pause

	ori PC, PWROFF
	jmp .

do_menu_mft:
	eqiw LO(menu_active), 0
	?jmp do_menu               ! MENU/MFT in menu never MFT
	offiw LO(kbd_flags), SHIFT
	?jmp do_mft
	jmp do_menu

do_ok_lock:
	eqiw LO(menu_active), 0
	?jmp menu_ok               ! OK/LOCK in menu likewise never LOCK
	offiw LO(kbd_flags), SHIFT
	?jmp do_lock
	jmp do_ok

do_r_alpha:
	offiw LO(kbd_flags), SHIFT
	?jmp do_alpha
	jmp do_r

do_next_prev:
	eqiw LO(menu_active), 0
	?jmp menu_next_prev

	call scan_stop

	offiw LO(kbd_flags), SHIFT
	?jmp do_prev
	jmp do_next

do_rcl_sto:
	eqiw LO(menu_active), 0
	?jmp menu_rcl_sto

	call scan_stop

	offiw LO(kbd_flags), SHIFT
	?jmp do_sto
	jmp do_rcl

!----------------------------------------------------------------------
do_clear:
	offiw LO(kbd_flags), SHIFT
	?jr 2f
	mov A, [kbd_index]
	dcr A
	?jr 1f
2:
	mvi A, 0
1:
	mov [kbd_index], A
	call fcn_off

	jmp redraw

do_plus:
	offiw LO(tx_on), 1
	?jmp pwr_inc                     ! + TXPWR if xmit
	eqiw LO(kbd_index), 0
	?jmp do_next_from_outer_space    ! + FREQ if digits

	offiw LO(kbd_flags), SHIFT
	?jmp sq_inc                      ! +SQ if FCN
	jmp vol_inc                      ! vol otherwise

do_minus:
	offiw LO(tx_on), 1
	?jmp pwr_dec
	eqiw LO(kbd_index), 0
	?jmp do_prev_from_outer_space    ! - FREQ if digits

	offiw LO(kbd_flags), SHIFT
	?jmp sq_dec
	eqi B, 0
	?jmp vol_mute    ! typematic -, mute instead (AND HURRY !)
	jmp vol_dec

do_mute:
	offiw LO(kbd_flags), SHIFT
	?jmp sq_auto
	jmp sq_override

do_mft:
	call fcn_off
	ret

do_ok:
	call scan_stop

	eqiw LO(kbd_index), 0
	?jmp do_enter_really         ! digits OK

	mov A, [duplex_state]
	nei A, 2
	?jmp ok_with_reverse_duplex ! OK during input monitoring

	jmp recall_my_favorites     ! plain OK


do_fcn:
	mviw LO(timer_fcn), 15
	mov A, [kbd_flags]
	xri A, SHIFT
	mov [kbd_flags], A
	jmp mbus_update_lights

do_alpha:
	call fcn_off
	mov A, [kbd_flags]
	xri A, ALPHA
	mov [kbd_flags], A
	jmp mbus_update_lights

do_lock:
	call fcn_off
	mov A, [kbd_flags]
	xri A, KEYLOCK
	mov [kbd_flags], A
	jmp mbus_update_lights

do_rcl:
	call scan_stop

	neiw LO(kbd_index), 0
	?jmp recall_previous_freqs

	call get_the_number
	call recall_memory
	ret

do_sto:
	call fcn_off

	call scan_stop

	offiw LO(kbd_flags), ALPHA
	?jmp name_memory                     ! STO in ALPHA state

	neiw LO(kbd_index), 0
	?jmp store_next_free_memory          ! STO without digits

	call get_the_number
	call store_memory
	ret

do_next:
	call scan_stop

	gtiw LO(mem_idx), 99
	?jmp memory_next

do_next_from_outer_space:
	call scan_stop

	call repeat_count
	adi C, 1
	lxi HL, rx_freq
	call step_channels_up
	call leave_memories
	call set_duplex_wrt_freq
	call freq_changed
	jmp redraw

do_prev:
	call scan_stop

	gtiw LO(mem_idx), 99
	?jmp memory_prev

do_prev_from_outer_space:
	call scan_stop

	call repeat_count
	adi C, 1
	lxi HL, rx_freq
	call step_channels_down
	call leave_memories
	call set_duplex_wrt_freq
	call freq_changed
	jmp redraw

!  duplex state might be 3, reset here to 0..2

do_r:
	call scan_stop

	mov A, [duplex_state]
	nei A, 1
	?call enter_reverse_duplex  ! 1 to 2 fixups
	mov A, [duplex_state]
	nei A, 2
	?call leave_reverse_duplex  ! 2 to 0 fixups

	mov A, [duplex_state]
	adi A, 1
	lti A, 3
	?mvi A, 0
	mov [duplex_state], A

	call freq_changed
	jmp redraw

do_star:
	call scan_stop

	offiw LO(kbd_flags), ALPHA
	?jmp alpha_star_input             ! ALPHA was not off, go stash '*'

	eqiw LO(kbd_index), 0
	?jmp ccir_from_buffer

	nei B, 0
	?jmp repeater_beep         ! once only

	ret

! PTT button. Sticky TX without real PTT ?

do_ptt_button:
	call scan_stop

	oniw LO(tx_on), 4
	?jr 1f
	aniw LO(tx_on), ~4
	jmp check_tx_state
1:
	oriw LO(tx_on), 4
	jmp check_tx_state

! Button with the small handset in it.

do_handset:
	ret

! HF button

do_hf:
	eqiw LO(kbd_index), 0
	?jmp scan_start

	neiw LO(scan_state), 0      ! already scanning.
	?jmp scan_start             ! ?Not. so start.

	call scan_stop
	jmp redraw

do_enter:
	call scan_stop

	offiw LO(kbd_flags), ALPHA
	?jmp chr_input             ! ALPHA was not off, go stash '#'

do_enter_really:
	call scan_stop

	eqiw LO(menu_active), 0
	?call menu_accept

	neiw LO(menu_active), 0
	?call cmd_accept

	mviw LO(kbd_index), 0
	call redraw
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
cmd_accept:
	mov A, [kbd_index]
	nei A, 0
	?ret
	gti A, 2
	?jmp cmd_memory
	nei A, 3
	?jmp cmd_3_digits
	nei A, 4
	?jmp cmd_4_digits

	jmp cmd_frequency

!----------------------------------------------------------------------
!
cmd_memory:
	call get_the_number
	jmp recall_memory

cmd_3_digits:
	jmp prep_implied_first

cmd_4_digits:
	jmp prep_implied_first

cmd_5_digits:
	jmp prep_implied_first

cmd_frequency:
	lxi HL, kbd_buffer
	mov C, [kbd_index]
	jmp go_HLC_freq

go_HLC_freq:
	call buf2i
	lxi HL, rx_freq
	steax [HL]
	mov A, B
	stax [HL+2]

	call leave_memories
	call set_duplex_wrt_freq
	call freq_changed
	ret

prep_implied_first:
	lxi HL, cfg_freq_implied
	ldeax [HL]
	ldax [HL+2]
	mov B, A
	lxi HL, prt_buffer
	call i2buf                  ! prt_buffer has implied part of freq
	lxi DE, prt_buffer + 8
	lxi EA, kbd_buffer
	mov A, [kbd_index]
	eadd EA, A
	dmov HL, EA
	mov C, A                    ! overwrite from the end with kbd input
	jr 2f
1:
	dcx HL
	dcx DE
	ldax [HL]
	stax [DE]
2:
	dcr C
	?jr 1b
	lxi HL, prt_buffer
	mvi C, 8
	jmp go_HLC_freq

!----------------------------------------------------------------------
!
!
leave_memories:
	oriw LO(mem_idx), 0x80

	mviw LO(mem_name + 0), 0
	mviw LO(mem_name + 1), 0
	mviw LO(mem_name + 2), 0
	ret

memory_prev:
	call repeat_count

	mov A, [mem_idx]
	ani A, 0x7F
	mvi C, 100
1:
	sui A, 1
	lti A, 100
	?mvi A, 99
	mov E, A
	call index_memories
	ldax [HL]
	offi A, MEM_EXIST
	?jr 1f
	mov A, E
	dcr C
	?jr 1b
	ret                     ! Sorry.
1:
	mov A, E
	jmp recall_memory

memory_next:
	call repeat_count

	mov A, [mem_idx]
	ani A, 0x7F
	mvi C, 100
1:
	adi A, 1
	lti A, 100
	?mvi A, 0
	mov E, A
	call index_memories
	ldax [HL]
	offi A, MEM_EXIST
	?jr 1f
	mov A, E
	dcr C
	?jr 1b
	ret                     ! Sorry.
1:
	mov A, E
	jmp recall_memory

index_memories:
	lti A, 100
	?mvi A, 99
	mvi B, MEM_size
	mul B
	lxi HL, memories
	dadd EA, HL
	dmov HL, EA
	ret

name_memory:
	call alpha_off

	lxi HL, kbd_buffer
	lxi DE, mem_name

	mvi A, 0
	stax [DE]
	stax [DE+1]
	stax [DE+2]

	gtiw LO(kbd_index), 0
	?jr 1f
	ldax [HL]+
	stax [DE]+
	gtiw LO(kbd_index), 1
	?jr 1f
	ldax [HL]+
	stax [DE]+
	gtiw LO(kbd_index), 2
	?jr 1f
	ldax [HL]+
	stax [DE]+
1:
	mviw LO(kbd_index), 0

	mov A, [mem_idx]
	ani A, 0x7F
	call index_memories
	lxi EA, MEM_name
	dadd EA, HL
	dmov DE, EA

	lxi HL, mem_name
	ldax [HL]+
	stax [DE]+
	ldax [HL]+
	stax [DE]+
	ldax [HL]+
	stax [DE]+

	jmp redraw

store_next_free_memory:

	lxi EA, memories
	mvi B, 0
1:
	dmov HL, EA 
	ldax [HL]
	oni A, MEM_EXIST
	?jr 1f
	lxi HL, MEM_size
	dadd EA, HL
	adi B, 1
	gti B, 99
	?jr 1b
	ret                   ! Sorry
1:
	push BC
	mov A, B
	call store_memory

	pop BC
	mov A, B

	jmp recall_memory

store_memory:
	lti A, 100
	?ret
	mov C, A
	mvi B, MEM_size
	mul B
	lxi DE, memories
	dadd EA, DE
	dmov DE, EA

	mvi A, MEM_EXIST
	mov B, [duplex_state]
	nei B, 1
	?ori A, MEM_DUPLEX
	nei B, 3
	?ori A, MEM_OFFTX

	eqiw LO(rx_freq + 0), 0
	?jr 1f
	eqiw LO(rx_freq + 1), 0
	?jr 1f
	eqiw LO(rx_freq + 2), 0
	?jr 1f
	mvi A, 0                   ! no MEM_EXIST if cleared freq
1:
	stax [DE]+                 ; ASSERT(MEM_flags == 0)

	lxi HL, rx_freq
	call copy_long             ; ASSERT(MEM_rx == 1)
	inx DE
	inx DE
	inx DE

	lxi HL, tx_freq
	call copy_long             ; ASSERT(MEM_offtx == 4)
	inx DE
	inx DE
	inx DE

	lxi HL, mem_name
	call copy_long             ; ASSERT(MEM_name == 7)

	jmp redraw


recall_memory:
	lti A, 100
	?ret
	mov C, A                         ! remember memory number
	mvi B, MEM_size
	mul B
	lxi HL, memories
	dadd EA, HL                      ! record ptr
	dmov HL, EA

	ldax [HL]+                 ; ASSERT(MEM_flags == 0)
	oni A, MEM_EXIST
	?ret
	mov [mem_idx], C
	mov [mem_flags], A

	lxi DE, rx_freq            ; ASSERT(MEM_rx == 1)
	call copy_long
	inx HL
	inx HL
	inx HL
	lxi DE, tx_freq            ; ASSERT(MEM_offtx == 4)
	call copy_long             ! shortly overwritten unless separate tx
	inx HL
	inx HL
	inx HL
	lxi DE, mem_name           ; ASSERT(MEM_name == 7)
	call copy_long             ! shortly overwritten unless separate tx

	mov A, [mem_flags]
	mvi B, 0
	offi A, MEM_DUPLEX
	?mvi B, 1           ! normal duplex memory
	offi A, MEM_OFFTX
	?mvi B, 3           ! separate tx freq

	mov [duplex_state], B

	call freq_changed
	call redraw
	ret

!----------------------------------------------------------------------
!
!
recall_previous_freqs:
	jmp redraw

recall_my_favorites:
	lxi DE, rx_freq          ! what we will change
	lxi HL, cfg_callfreq
	call skip_if_different_freqs
	lxi HL, cfg_my_favorite
	call skip_if_not_empty_freq
	jmp do_enter_really

	call copy_long
	call leave_memories
	call set_duplex_wrt_freq
	call freq_changed
	call redraw
	ret

!----------------------------------------------------------------------
1:
	.ascii "RRRRR"

repeater_beep:
	call start_xmit
	lxi HL, 1b
	mvi C, 4
	call mbus_send_tones
	mvi A, 50
	call pause
	call stop_xmit
	ret

dtmf_from_buffer:
	call start_xmit
	lxi HL, kbd_buffer
	mov C, [kbd_index]
	call mbus_send_tones
	mov A, [kbd_index]
	adi A, 1
	mvi B, 10
	mul B
	mov A, EAL
	call pause
	call stop_xmit

	mviw LO(kbd_index), 0  ! This will clear the buffer. Use PTT to keep it.
	ret

ccir_from_buffer:
	lxi HL, kbd_buffer
	mov C, [kbd_index]
	eqi C, 1
	?jr 1f                 ! Use the digits themselves
	call buf2i             ! digit to number
	mov A, EAL
	call map_idx_to_txtone ! indirect to preset series [HL] (skip if set)
	ret                    ! huh ?
	call txtone_len
	nei C, 0
	?ret                  ! huh ?
1:
	push HL
	push BC
	call start_xmit
	pop BC
	pop HL
	call ccir_xmit
	call stop_xmit

	mviw LO(kbd_index), 0  ! This will clear the buffer. Use PTT to keep it.
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  MBUS intercourse
!
#include "mbus.asm" /* get the text */

handset_init:
	call mbus_constmsg; .ascii HS_ID, MBUSID, "f", VERSION_2; .byte 0
	call mbus_constmsg; .ascii HS_ID, MBUSID, "d", VERSION_1; .byte 0
	call mbus_constmsg; .ascii HS_ID, MBUSID, "s", "42"; .byte 0
	ret

!    0 "HSN2" "...." "v" "." \4         e.g. volume setting 0..9
!    0 "HSN2" "...." "l" "sT" \4        e.g. markers SERV=off, ROAM=on

mbus_sendvol:
	call prep_tx_msg

	mvi A, 'v'
	stax [DE]+

	mov A, [volume]
	gti A, 9
	?jr 1f
	mvi A, '1'
	stax [DE]+

	mov A, [volume]
	sui A, 10
1:
	adi A, '0'
	stax [DE]+

	jmp append_tail

mbus_sendsig:
	call prep_tx_msg

	mvi A, 's'
	stax [DE]+

	mov A, [sig_peak]
	lxi EA, 0
	mov EAL, A
	mvi B, 10
	div B

	mov A, EAL
	adi A, '0'
	nei A, '0'
	?mvi A, ' '
	stax [DE]+

	mov A, B
	adi A, '0'
	stax [DE]+

	mvi A, 's'             ! just a signal report
	eqiw LO(sq_forced), 0
	?mvi A, 'f'            ! one during forcibly opened squelch
	eqiw LO(sqopen), 0
	?mvi A, 'S'            ! wow, the squelch would be open
	eqiw LO(tx_on), 0
	?mvi A, 'T'            ! last, but not the least, we are transmitting
	stax [DE]+

	mviw LO(sq_changed), 0

	jmp append_tail

mbus_update_lights:
	call prep_tx_msg

	mvi A, 'l'
	stax [DE]+

	mvi A, 'F'
	oniw LO(kbd_flags), SHIFT
	?mvi A, 'f'
	stax [DE]+

	mvi A, 'A'
	oniw LO(kbd_flags), ALPHA
	?mvi A, 'a'
	stax [DE]+

	mvi A, 'K'
	oniw LO(kbd_flags), KEYLOCK
	?mvi A, 'k'
	stax [DE]+

	mvi A, 'h'
	eqiw LO(scan_state), 0
	?mvi A, 'H'
	stax [DE]+

	jmp append_tail

mbus_handset_blank:
	call prep_tx_msg

	mvi A, 'l' ! lightshow
	stax [DE]+

	mvi A, 'b' ! no backlight
	stax [DE]+
	mvi A, 'o' ! no ON
	stax [DE]+
	mvi A, 's' ! no SERV
	stax [DE]+

	jmp append_tail

mbus_send_tones:
	call prep_tx_msg
	mvi A, 'b'
	jmp mbus_send_stuff

mbus_send_upper:
	call prep_tx_msg
	mvi A, 'd'
	jmp mbus_send_stuff

mbus_send_lower:
	call prep_tx_msg
	mvi A, 'f'
	jmp mbus_send_stuff

prep_tx_msg:
	lxi DE, mbus_txmsg
	mvi A, 'H'
	stax [DE]+
	mvi A, 'S'
	stax [DE]+
	mvi A, 'N'
	stax [DE]+
	mvi A, '2'
	stax [DE]+
	mvi A, 'T'
	stax [DE]+
	mvi A, 'M'
	stax [DE]+
	mvi A, 'F'
	stax [DE]+
	mvi A, '1'
	stax [DE]+
	ret

mbus_send_stuff:
	stax [DE]+
	jmp append_data

1:
	ldax [HL]+
	stax [DE]+
append_data:
	dcr C
	?jr 1b       ! loop or FALLTHRU

append_tail:
	mvi A, 4
	stax [DE]+
	mvi A, 0
	stax [DE]+

	jmp mbus_send

!----------------------------------------------------------------------

mbus_newmsg:

	ldax [HL]+
	eqi A, 'A'
	?ret
	ldax [HL]+
	eqi A, 'N'
	?ret
	ldax [HL]+
	eqi A, 'Y'
	?ret
	ldax [HL]+
	eqi A, '1'
	?ret

	ldax [HL]+               ! sender at [HL] now
	nei A, 0xFF
	?ret
	ldax [HL]+
	nei A, 0xFF
	?ret
	ldax [HL]+
	nei A, 0xFF
	?ret
	ldax [HL]+
	nei A, 0xFF
	?ret

	ldax [HL]+     ! now after addresses, length at C, \4 not included

	nei A, 'M'
	?jmp msg_key_make
	nei A, 'R'
	?jmp msg_key_repeat

	ret ! hmph. dunno what it is.

!----------------------------------------------------------------------
! HL points to message data after command designator character.
! Length of data in C
! e.g. HL->"foobar", C=6

msg_key_make: !  XXX process N keys, not just one
	ldax [HL]+
	mvi B, 0
	jmp got_key

msg_key_repeat: !  XXX process N keys, not just one
	ldax [HL]+
	mvi B, 1
	jmp got_key

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Configuration menu
!
!  - MENU enters/leaves menu (into last selected level and index)
!  - NEXT/PREV steps menu at the current level
!  - OK descends into current submenu from mainmenu level or 
!       ascends back to mainmenu level

menu_init:
	lxi HL, menu_main
	shld [menu_ptr]
	shld [menu_topptr]
	ret

do_menu:
	neiw LO(kbd_index), 0
	?jr 1f
	mvi A, 1                       ! entering menu with shortcut number
	mov [menu_active], A
	call menu_shortcut
	jmp redraw
1:
	mov A, [menu_active]
	xri A, 1
	mov [menu_active], A           ! flip master in/out of menu switch.
	nei A, 0
	?jr 1f
	call menu_enter                ! entering last location
	jmp redraw
1:
	offiw LO(kbd_flags), SHIFT     ! leaving.
	?call fcn_off                  ! clear FCN 
	jmp redraw

! shortcut to numbered top record

menu_shortcut:
	call get_the_number
	mvi B, 16
	mul B                  ! offset (3 * 16) to EA
	lxi DE, menu_main
	lxi HL, end_menu_main - 16
	dadd EA, DE

	dlt EA, HL
	?dmov EA, HL
	dgt EA, DE
	?dmov EA, DE

	dmov HL, EA
	shld [menu_topptr]
	shld [menu_ptr]
	call menu_enter
	ret

! Process each keystroke maybe specially in submenu level
! Input character(s) are already in buffer
! We will do the lower row painting

menu_input:

	lhld [menu_ptr]
	ldax [HL+offset_type] ! type
	nei A, CFG_TAB
	?jmp menu_input_tab
	nei A, CFG_DIGIT
	?jmp menu_input_digit

	jmp draw_kbd_buffer            ! else dont care until #

menu_input_digit:
menu_input_tab:
	mov A, [kbd_index]
	gti A, 1              ! Another char, but only one allowed. overwrite 1st.
	?jr 1f
	mov A, [kbd_buffer + 1]
	mov [kbd_buffer], A
	mvi A, 1
	mov [kbd_index], A
1:
	jmp draw_menu_lower

menu_rcl_sto:                 ! XXX fetch default for current only
	ret

menu_next_prev:
	call repeat_count
1:
	push BC
	call 1f
	pop BC
	dcr C
	?jr 1b
	call menu_enter
	jmp redraw
1:
	lxi EA, 16
	offiw LO(kbd_flags), SHIFT
	?lxi EA, -16         ! Next +1, Prev -1

	lhld [menu_ptr]
	ldax [HL+offset_type] ! are we stepping at top or sublevel
	dadd EA, HL           ! nudge new ptr into EA

	eqi A, CFG_NOTYPE     ! we are at toplevel.
	?jr 1f

	! walk top level

	lxi HL, end_menu_main
	dlt EA, HL                  ! new did not overrun
	?lxi EA, menu_main          ! ?Not. rewind to first
	lxi HL, menu_main - 1
	dgt EA, HL                  ! did not underrun
	?lxi EA, end_menu_main - 16 ! ?Not. flip to last
	dmov HL, EA
	shld [menu_topptr]
	shld [menu_ptr]
	ret
1:
	! walk at sublevel

	push EA
	lhld [menu_topptr]          ! rangecheck from toplevel
	ldeax [HL+offset_ptr]       ! first record
	dmov BC, EA           
	ldeax [HL+offset_arg]       ! last record
	dmov DE, EA           
	pop EA
	dlt EA, BC           ! below first
	?jr 1f
	dmov EA, DE          ! point to last
1:
	dgt EA, DE           ! above last
	?jr 1f
	dmov EA, BC          ! point to last
1:
	dmov HL, EA
	shld [menu_ptr]
	ret

menu_ok:

	lhld [menu_ptr]
	ldax [HL+offset_type]
	nei A, CFG_NOTYPE
	?jr 1f

	! OK on sublevel

	eqiw LO(kbd_index), 0
	?jmp do_enter_really    ! 123 OK translates to 123 #

	lhld [menu_topptr]      ! else ascend to toplevel
	shld [menu_ptr]
	call menu_enter
	jmp redraw
1:
	! OK on toplevel, descend

	eqiw LO(kbd_index), 0
	?jmp 1f

	ldeax [HL+offset_ptr]   ! 1st subrecord
	dmov HL, EA
	shld [menu_ptr]
	call menu_enter
	jmp redraw

1:
	!  descend to a numbered record

	call get_the_number     ! e.g. 3 OK

	lhld [menu_ptr]
	ldeax [HL+offset_arg]   ! last subrecord
	dmov DE, EA
	ldeax [HL+offset_ptr]   ! 1st subrecord
	dmov HL, EA

	mvi B, 16
	mul B         ! offset (3 * 16) to EA
	dadd EA, HL

	dlt EA, DE
	?dmov EA, DE        ! not < last
	dgt EA, HL
	?dmov EA, HL        ! not > 1st

	dmov HL, EA
	shld [menu_ptr]
	call menu_enter
	jmp redraw

!
!  Entered into new record
!
menu_enter:
	ret

!  Accept current keyboard input buffer as the new value for current
!  configuration record.
!  Adjust to fit in min/max values.

menu_accept:

	mov C, [kbd_index]
	nei C, 0
	?ret

	mviw LO(kbd_index), 0

	lhld [menu_ptr]
	ldax [HL+offset_type]

	! HL has record pointer
	! A has input type
	! C has length of input

	nei A, CFG_NOTYPE
	?ret
	nei A, CFG_DYN
	?ret

	nei A, CFG_EXEC      ! XXX no functionality yet
	?ret

	nei A, CFG_RST
	?jmp menu_accept_666_reset

	nei A, CFG_TAB
	?jmp menu_accept_tab

	nei A, CFG_FOFF
	?jmp menu_accept_f
	nei A, CFG_FREQ
	?jmp menu_accept_f
	nei A, CFG_BYTE
	?jmp menu_accept_byte
	nei A, CFG_PERCENT
	?jmp menu_accept_percent
	nei A, CFG_WORD
	?jmp menu_accept_word
	nei A, CFG_DIGIT
	?jmp menu_accept_digit
	nei A, CFG_MSEC
	?jmp menu_accept_msec
	nei A, CFG_SEC
	?jmp menu_accept_sec
	nei A, CFG_MINUTE
	?jmp menu_accept_minute
	nei A, CFG_STRING
	?jmp menu_accept_string

	jmp canada

menu_accept_666_reset:
	eqi C, 3
	?ret
	mov A, [kbd_buffer + 0]
	eqi A, '6'
	?ret
	mov A, [kbd_buffer + 1]
	eqi A, '6'
	?ret
	mov A, [kbd_buffer + 2]
	eqi A, '6'
	?ret

	ldeax [HL+offset_arg]
	push EA
	ret                       ! you asked for it.

menu_accept_tab:
	mov A, [kbd_buffer + 0]
	sui A, '1'
	ldeax [HL+offset_ptr]
	dmov DE, EA
	stax [DE]                 ! XXX rangecheck

		call update_LFU_come  ! sigh. XXX

	ret

menu_accept_digit:
	mov A, [kbd_buffer + 0]
	sui A, '0'
	ldeax [HL+offset_ptr]
	dmov DE, EA
	stax [DE]                 ! XXX rangecheck

		call update_LFU_vol ! XXX silly

	ret

menu_accept_string:
	ldax [HL+offset_arg]  ! destination length A
	ldeax [HL+offset_ptr]
	dmov DE, EA            ! destination DE
	lxi HL, kbd_buffer   ! source HL, length C
	lta C, A
	?mov C, A           ! cut excess
	sub A, C           ! needed padding
	mov B, A
	jr 2f
1:
	ldax [HL]+
	stax [DE]+ ! bcopy
2:
	dcr C
	?jr 1b
	jr 2f
1:
	mvi A, 0
	stax [DE]+  ! pad with \0
2:
	dcr B
	?jr 1b
	ret

menu_accept_f:
	ldeax [HL+offset_ptr]
	push EA              ! destination of freq
	lxi HL, kbd_buffer    ! length C
	call buf2i             ! HL[C] into BEA
	pop DE
	steax [DE]
	mov A, B
	stax [DE+2]
	ret

menu_accept_byte:
menu_accept_sec:
menu_accept_minute:
	ldeax [HL+offset_ptr]
	push EA                ! destination of byte
	lxi HL, kbd_buffer     ! length in C
	call buf2i
	dmov HL, EA
	mov A, EAL             ! accept values 0...255
	eqi H, 0
	?mvi A, 255            ! Middle byte nonz, clamp
	eqi B, 0
	?mvi A, 255            ! MSByte nonz, clamp
	pop DE
	stax [DE]
	ret

menu_accept_percent:
	ldeax [HL+offset_ptr]
	push EA            ! destination of word
	lxi HL, kbd_buffer ! length C
	call buf2i
	eqi B, 0
	?lxi EA, 100       ! MSByte nonz, clamp into 100
	mov A, EAH
	eqi A, 0
	?lxi EA, 100       ! Middle nonz, ditto
	mov A, EAL
	lti A, 100
	?mvi A, 100        ! finally here.
	pop DE
	stax [DE]

		call DAC_update ! XXX silly

	ret

menu_accept_word:
menu_accept_msec:
	ldeax [HL+offset_ptr]
	push EA            ! destination of word
	lxi HL, kbd_buffer ! length C
	call buf2i
	eqi B, 0
	?lxi EA, 65535     ! MSByte nonz, clamp
	pop DE
	steax [DE]
	ret

draw_menu:

	lhld [menu_ptr]
	lxi EA, offset_title
	dadd EA, HL
	dmov HL, EA         ! title
	mvi C, 8            ! length

	call mbus_send_upper

draw_menu_lower:

	lhld [menu_ptr]
	ldax [HL+offset_type]

	nei A, CFG_NOTYPE
	?jmp draw_kbd_buffer  ! not in submenu, just show any input

	nei A, CFG_RST
	?jmp draw_menu_resets
	nei A, CFG_DYN
	?jmp draw_menu_dyn
	nei A, CFG_TAB
	?jmp draw_menu_tab

	mov B, [kbd_index]
	eqi B, 0
	?jmp draw_kbd_buffer  ! kbd input accepted for below types

	nei A, CFG_EXEC       ! XXX no functionality yet
	?jmp draw_menu_execs

	nei A, CFG_FOFF
	?jmp draw_menu_foff
	nei A, CFG_FREQ
	?jmp draw_menu_freq
	nei A, CFG_BYTE
	?jmp draw_menu_byte
	nei A, CFG_PERCENT
	?jmp draw_menu_percent
	nei A, CFG_WORD
	?jmp draw_menu_word
	nei A, CFG_DIGIT
	?jmp draw_menu_digit
	nei A, CFG_MSEC
	?jmp draw_menu_msec
	nei A, CFG_SEC
	?jmp draw_menu_sec
	nei A, CFG_MINUTE
	?jmp draw_menu_minute
	nei A, CFG_STRING
	?jmp draw_menu_string
	nei A, CFG_VOLT
	?jmp draw_menu_volt

	jmp canada

draw_menu_execs:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.asciz "       ?"

draw_menu_string:
	ldax [HL+offset_arg]  ! max length
	mov C, A
	ldeax [HL+offset_ptr]
	dmov HL, EA
	mvi B, 0    ! check nonzero length
1:
	ldax [HL+B]
	nei A, 0    ! not \0.
	?jr 1f
	adi B, 1
	mov A, C
	eqa B, A    ! last.
	?jr 1b
1:
	mov A, B
	mov C, A
	jmp mbus_send_lower

draw_menu_freq:
draw_menu_foff:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	ldax [HL+2]
	mov B, A
	lxi HL, prt_buffer
	call i2buf
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_menu_byte:
draw_menu_digit:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	mvi A, 0
	mov EAH, A
	call format_EA
	lxi HL, prt_buffer + 2
	mvi C, 3
	jmp mbus_send_lower

draw_menu_word:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	call format_EA
	lxi HL, prt_buffer
	mvi C, 5
	jmp mbus_send_lower

draw_menu_msec:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	call format_EA
	lxi HL, prt_buffer + 5 ! "65535 ms"
	mvi A, ' '
	stax [HL]+
	mvi A, 'm'
	stax [HL]+
	mvi A, 's'
	stax [HL]+
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_menu_percent:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldax [HL]
	lti A, 100
	?mvi A, 100
	lxi EA, 0
	mov EAL, A
	call format_EA
	lxi HL, prt_buffer + 5 ! "  255 %"
	mvi A, ' '
	stax [HL]+
	mvi A, '%'
	stax [HL]+
	lxi HL, prt_buffer + 2
	mvi C, 5
	jmp mbus_send_lower

draw_menu_volt:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldax [HL]
	lxi EA, 0
	mov EAL, A
	call format_EA
	lxi HL, prt_buffer + 5 ! "  255 V"
	mvi A, ' '
	stax [HL]+
	mvi A, 'V'
	stax [HL]+
	lxi HL, prt_buffer + 2
	mvi C, 5
	jmp mbus_send_lower

draw_menu_minute:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	mvi A, 0
	mov EAH, A
	call format_EA
	lxi HL, prt_buffer + 5 ! "  255 min"
	mvi A, ' '
	stax [HL]+
	mvi A, 'm'
	stax [HL]+
	mvi A, 'i'
	stax [HL]+
	mvi A, 'n'
	stax [HL]+
	lxi HL, prt_buffer + 2
	mvi C, 7
	jmp mbus_send_lower

draw_menu_sec:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	mvi A, 0
	mov EAH, A
	call format_EA
	lxi HL, prt_buffer + 5 ! "  255 sec"
	mvi A, ' '
	stax [HL]+
	mvi A, 's'
	stax [HL]+
	mvi A, 'e'
	stax [HL]+
	mvi A, 'c'
	stax [HL]+
	lxi HL, prt_buffer + 2
	mvi C, 7
	jmp mbus_send_lower

draw_menu_resets:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.asciz "    666?"

draw_menu_dyn:
	lxi EA, hack_for_center ! yucko
	dne EA, HL
	?jmp draw_center_display
	lxi EA, 1f
	push EA               ! return 3 lines below
	ldeax [HL+offset_arg]
	push EA               ! stub routine address
	lxi EA, 0             ! prepare default for EAH in case byte value
	ret                   ! jump, result back in EA
1:
	call format_EA
	lxi HL, prt_buffer
	mvi C, 5
	jmp mbus_send_lower

draw_menu_tab:
	ldeax [HL+offset_ptr]  ! pointer to real value
	dmov DE, EA
	mov A, [kbd_buffer]
	sui A, '1'             ! tentative new value '1'...'9' for 0...8
	neiw LO(kbd_index), 0
	?ldax [DE]             ! no pending value, use real one
	mov B, A
	ldeax [HL+offset_arg]  ! get selection list
	dmov HL, EA            ! remember first
	jr 2f
1:
	mvi A, 8              ! length of one string
	eadd EA, A            ! next one please
	dmov DE, EA
	ldax [DE]
	nei A, 0
	?jr 3f             ! no such string, use first one
2:
	dcr B
	?jr 1b
	dmov HL, EA        ! Select this string
3:

	lxi DE, prt_buffer
	mvi C, 0
1:
	ldax [HL]+
	nei A, 0
	?jr 1f
	stax [DE]+
	adi C, 1
	jr 1b
1:
	lxi HL, prt_buffer

	mov B, [kbd_index]
	nei B, 0           ! We are editing.
	?jr 2f             ! ?Not. jump over, "    MIC" displayed"

	! Yes, editing. append blanks to get the value to the left.
1:
	lti C, 8
	?jr 2f
	mvi A, ' '
	stax [DE]+
	adi C, 1
	jr 1b
2:
	jmp mbus_send_lower

! XXX scale the reading into Hz

draw_center_display:
	lxi HL, afc_count
	ldeax [HL]
	mvi B, '-'            ! sign
	lxi HL, AFC_CNT0 / 2  ! minus/plus infinity for us
	dgt EA, HL            ! count negative, input more than 455kHz
	?jr 1f                ! count positive, input less than 455kHz
	mvi B, '+'
	dmov HL, EA
	lxi EA, AFC_CNT0
	dsub EA, HL
1:
	lxi HL, 1000          ! shuffle the sleeves
	dlt EA, HL            ! reading is in valid range
	?jr 1f
	call format_EA          ! Better keep B
	mov [prt_buffer + 5], B ! append sign
	mvi C, 6
	lxi HL, prt_buffer
	jmp mbus_send_lower
1:
	mvi C, 4
	lxi HL, 1f
	jmp mbus_send_lower
1:
	.ascii "??? "
!----------------------------------------------------------------------

read_FSKL:
	mov A, [ad_FSKL]
	mov EAL, A
	ret
read_BCR:
	mov A, [ad_BCR]
	mov EAL, A
	ret
read_BTMP:
	mov A, [ad_BTMP]
	xri A, 0xFF			! OH3NWQ 
	mov EAL, A
	ret
read_RSSI:
	mov A, [ad_RSSI]
	mov EAL, A
	ret
read_PFB:
	mov A, [ad_PFB]
	mov EAL, A
	ret
read_BATT:
	mov A, [ad_BATT]
	call map_byte_to_voltage	! OH3NWQ
	mov EAL, A
	ret
read_TEMP:
	mov A, [ad_TEMP]
	xri A, 0xFF			! OH3NWQ 
	mov EAL, A
	ret
read_LOCK:
	mov A, [ad_LOCK]
	mov EAL, A
	ret

read_afc:
	lxi HL, afc_count
	ldeax [HL]
	ret

read_masd:
	mov A, [MODEM_DATA]
	mov EAL, A
	ret

read_mass:
	mov A, [MODEM_CSR]
	mov EAL, A
	ret

!----------------------------------------------------------------------
! copy defaults from menu

cfg_rst_some:
	lxi HL, menu_main
1:
	push HL
	call 1f               ! reset this submenu
	pop HL
	lxi EA, 16
	dadd EA, HL
	dmov HL, EA
	lxi EA, end_menu_main
	deq EA, HL
	?jr 1b

	jmp 0                      ! reboot
1:
	ldeax [HL+offset_arg]
	dmov BC, EA               ! last record ptr
	ldeax [HL+offset_ptr]
	dmov HL, EA               ! first
1:
	call 1f             ! reset this record
	dmov EA, BC
	dne EA, HL
	?ret                ! did last.
	lxi EA, 16
	dadd EA, HL
	dmov HL, EA
	jr 1b
1:
	ldeax [HL+offset_ptr]   ! address of variable
	dmov DE, EA
	lxi EA, 0
	dne EA, DE
	?ret                    ! has no address
	ldax [HL+offset_type]
	nei A, CFG_FREQ
	?jmp cfg_rst_freq
	nei A, CFG_FOFF
	?jmp cfg_rst_foff
	nei A, CFG_TAB
	?jmp cfg_rst_byte
	nei A, CFG_DIGIT
	?jmp cfg_rst_byte
	nei A, CFG_BYTE
	?jmp cfg_rst_byte
	nei A, CFG_WORD
	?jmp cfg_rst_word
	nei A, CFG_PERCENT
	?jmp cfg_rst_byte
	nei A, CFG_MSEC
	?jmp cfg_rst_msec
	nei A, CFG_SEC
	?jmp cfg_rst_byte
	nei A, CFG_MINUTE
	?jmp cfg_rst_byte
	nei A, CFG_STRING
	?jmp cfg_rst_string
	ret

cfg_rst_freq:
cfg_rst_foff:
	ldax [HL+offset_default+2]
	stax [DE+2]
cfg_rst_word:
cfg_rst_msec:
	ldax [HL+offset_default+1]
	stax [DE+1]
cfg_rst_byte:
	ldax [HL+offset_default+0]
	stax [DE+0]
	ret

cfg_rst_string:
	mvi A, 0
	stax [DE]   ! no defaults for strings
	ret

!----------------------------------------------------------------------
! just wipe them out

cfg_rst_mems:
	lxi HL, memories
	lxi EA, end_memories
	mvi A, 0
1:
	stax [HL]+
	deq EA, HL
	?jr 1b

	jmp 0

!----------------------------------------------------------------------
! clear all of ram

cfg_suicide:
	lxi HL, ram
	lxi EA, 0
	mvi A, 0
1:
	stax [HL]+
	deq EA, HL
	?jr 1b

	jmp 0

!----------------------------------------------------------------------
!----------------------------------------------------------------------
! Nill taulukoilla nyttisi tulevan suhtkoht tasainen 
! tehokyr. Ongelmana tietenkin on se ett alapss
! portaat ovat karkeammat. Kokeilin tt hieman eilenillala.
! 
! Huomaa ett tysi teho (mun mittarin mukaan 23W - on ehk jotain
! 17W todellista) saavutetaan jo 5 V ohjauksella siihen teho-ohjauspinniin.
! TMN1 manuskan mukaan ohjausjnnite on max 7V.
! 
! ... time passes...
!
! Hh sehn onkin nelillinen
! eik eksponentiaalinen - back to the drawing board...
!
! ... time passes...
!
! Mittauksieni mukaan vasta arvo 48 antaa saman kuin coarse:n pykl.
! Tein uuden taulun sen mukaisesti.
!
! Vesku OH3NWQ
!---------------
 
txpwr_curve:                 ! values are not shifted, but LSbit aligned
	! coarse, fine	  Watt   fract %
	.byte  0,  0	! 0.000 0.0000 0
	.byte  0,  1	! 0.170 0.0001 1 XXX handtuned by Vesku
	.byte  0,  2	! 0.340 0.0004 2 XXX
	.byte  0,  3	! 0.510 0.0009 3 XXX
	.byte  0,  4	! 0.680 0.0016 4 XXX
	.byte  0,  5	! 0.850 0.0025 5 XXX
	.byte  0,  6	! 1.020 0.0036 6 XXX
	.byte  0,  7	! 1.190 0.0049 7 XXX
	.byte  0,  9	! 1.360 0.0064 8 XXX
	.byte  0, 11	! 1.530 0.0081 9
	.byte  0, 14	! 1.700 0.0100 10
	.byte  0, 17	! 1.870 0.0121 11
	.byte  0, 20	! 2.040 0.0144 12
	.byte  0, 24	! 2.210 0.0169 13
	.byte  0, 28	! 2.380 0.0196 14
	.byte  0, 32	! 2.550 0.0225 15
	.byte  0, 37	! 2.720 0.0256 16
	.byte  0, 42	! 2.890 0.0289 17
	.byte  1,  1	! 3.060 0.0324 18 XXX
	.byte  1,  5	! 3.230 0.0361 19
	.byte  1, 11	! 3.400 0.0400 20
	.byte  1, 17	! 3.570 0.0441 21
	.byte  1, 23	! 3.740 0.0484 22
	.byte  1, 30	! 3.910 0.0529 23
	.byte  1, 36	! 4.080 0.0576 24
	.byte  1, 44	! 4.250 0.0625 25
	.byte  2,  4	! 4.420 0.0676 26
	.byte  2, 12	! 4.590 0.0729 27
	.byte  2, 20	! 4.760 0.0784 28
	.byte  2, 28	! 4.930 0.0841 29
	.byte  2, 37	! 5.100 0.0900 30
	.byte  2, 46	! 5.270 0.0961 31
	.byte  3,  8	! 5.440 0.1024 32
	.byte  3, 17	! 5.610 0.1089 33
	.byte  3, 27	! 5.780 0.1156 34
	.byte  3, 37	! 5.950 0.1225 35
	.byte  4,  0	! 6.120 0.1296 36
	.byte  4, 11	! 6.290 0.1369 37
	.byte  4, 22	! 6.460 0.1444 38
	.byte  4, 33	! 6.630 0.1521 39
	.byte  4, 45	! 6.800 0.1600 40
	.byte  5,  9	! 6.970 0.1681 41
	.byte  5, 22	! 7.140 0.1764 42
	.byte  5, 34	! 7.310 0.1849 43
	.byte  6,  0	! 7.480 0.1936 44
	.byte  6, 13	! 7.650 0.2025 45
	.byte  6, 26	! 7.820 0.2116 46
	.byte  6, 39	! 7.990 0.2209 47
	.byte  7,  6	! 8.160 0.2304 48
	.byte  7, 20	! 8.330 0.2401 49
	.byte  7, 35	! 8.500 0.2500 50
	.byte  8,  2	! 8.670 0.2601 51
	.byte  8, 17	! 8.840 0.2704 52
	.byte  8, 33	! 9.010 0.2809 53
	.byte  9,  1	! 9.180 0.2916 54
	.byte  9, 17	! 9.350 0.3025 55
	.byte  9, 33	! 9.520 0.3136 56
	.byte 10,  3	! 9.690 0.3249 57
	.byte 10, 20	! 9.860 0.3364 58
	.byte 10, 37	! 10.030 0.3481 59
	.byte 11,  7	! 10.200 0.3600 60
	.byte 11, 25	! 10.370 0.3721 61
	.byte 11, 43	! 10.540 0.3844 62
	.byte 12, 14	! 10.710 0.3969 63
	.byte 12, 32	! 10.880 0.4096 64
	.byte 13,  4	! 11.050 0.4225 65
	.byte 13, 23	! 11.220 0.4356 66
	.byte 13, 43	! 11.390 0.4489 67
	.byte 14, 15	! 11.560 0.4624 68
	.byte 14, 35	! 11.730 0.4761 69
	.byte 15,  8	! 11.900 0.4900 70
	.byte 15, 29	! 12.070 0.5041 71
	.byte 16,  3	! 12.240 0.5184 72
	.byte 16, 24	! 12.410 0.5329 73
	.byte 16, 45	! 12.580 0.5476 74
	.byte 17, 20	! 12.750 0.5625 75
	.byte 17, 42	! 12.920 0.5776 76
	.byte 18, 17	! 13.090 0.5929 77
	.byte 18, 40	! 13.260 0.6084 78
	.byte 19, 16	! 13.430 0.6241 79
	.byte 19, 39	! 13.600 0.6400 80
	.byte 20, 15	! 13.770 0.6561 81
	.byte 20, 39	! 13.940 0.6724 82
	.byte 21, 16	! 14.110 0.6889 83
	.byte 21, 41	! 14.280 0.7056 84
	.byte 22, 18	! 14.450 0.7225 85
	.byte 22, 43	! 14.620 0.7396 86
	.byte 23, 21	! 14.790 0.7569 87
	.byte 24,  0	! 14.960 0.7744 88
	.byte 24, 26	! 15.130 0.7921 89
	.byte 25,  5	! 15.300 0.8100 90
	.byte 25, 31	! 15.470 0.8281 91
	.byte 26, 11	! 15.640 0.8464 92
	.byte 26, 38	! 15.810 0.8649 93
	.byte 27, 18	! 15.980 0.8836 94
	.byte 27, 45	! 16.150 0.9025 95
	.byte 28, 26	! 16.320 0.9216 96
	.byte 29,  7	! 16.490 0.9409 97
	.byte 29, 36	! 16.660 0.9604 98
	.byte 30, 18	! 16.830 0.9801 99

	.byte 63, 63	! 17.000 1.0000 100 XXX MAXIMUM RISK starring J.C. VanDamme

	ASSERT((. - txpwr_curve) == 202)  ! 101 words


!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
! feel free to skip the gunk with /-------
!
! 1 is dit, 0 is dash, terminating pattern 10*
! not quite complete.

cw_tab:
	.org cw_tab + '"'
	.byte 0b10110110 ! "
	.org cw_tab + '\''
	.byte 0b10000110 ! '
	.org cw_tab + '('
	.byte 0b01001010 ! (
	.byte 0b01001010 ! ) ) balance is everything
	.org cw_tab + ','
	.byte 0b00110010 ! ,
	.byte 0b01111010 ! -
	.byte 0b10101010 ! .
	.byte 0b01101100 ! /
	.org cw_tab + '0'
	.byte 0b00000100 ! 0
	.byte 0b10000100 ! 1
	.byte 0b11000100 ! 2
	.byte 0b11100100 ! 3
	.byte 0b11110100 ! 4
	.byte 0b11111100 ! 5
	.byte 0b01111100 ! 6
	.byte 0b00111100 ! 7
	.byte 0b00011100 ! 8
	.byte 0b00001100 ! 9
	.byte 0b00011110 ! :
	.org cw_tab + '?'
	.byte 0b11001110 ! ?
	.org cw_tab + 'A'
	.byte 0b10100000 ! A
	.byte 0b01111000 ! B
	.byte 0b01011000 ! C
	.byte 0b01110000 ! D
	.byte 0b11000000 ! E
	.byte 0b11011000 ! F
	.byte 0b00110000 ! G
	.byte 0b11111000 ! H
	.byte 0b11100000 ! I
	.byte 0b10001000 ! J
	.byte 0b01010000 ! K
	.byte 0b10111000 ! L
	.byte 0b00100000 ! M
	.byte 0b01100000 ! N
	.byte 0b00010000 ! O
	.byte 0b10011000 ! P
	.byte 0b00101000 ! Q
	.byte 0b10110000 ! R
	.byte 0b11110000 ! S
	.byte 0b01000000 ! T
	.byte 0b11010000 ! U
	.byte 0b11101000 ! V
	.byte 0b10010000 ! W
	.byte 0b01101000 ! X
	.byte 0b01001000 ! Y
	.byte 0b00111000 ! Z
	.byte 0b10101000 ! aiti
	.byte 0b10100110 ! ruats. o
	.byte 0b00011000 ! oljy

	.org cw_tab + 128

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
! feel free to skip the gunk with /-------

	.align 8,0xFF		! Necessary
crctbl_hi:
	.byte HI(0)
	.byte HI(4489)
	.byte HI(8978)
	.byte HI(12955)
	.byte HI(17956)
	.byte HI(22445)
	.byte HI(25910)
	.byte HI(29887)
	.byte HI(35912)
	.byte HI(40385)
	.byte HI(44890)
	.byte HI(48851)
	.byte HI(51820)
	.byte HI(56293)
	.byte HI(59774)
	.byte HI(63735)
	.byte HI(4225)
	.byte HI(264)
	.byte HI(13203)
	.byte HI(8730)
	.byte HI(22181)
	.byte HI(18220)
	.byte HI(30135)
	.byte HI(25662)
	.byte HI(40137)
	.byte HI(36160)
	.byte HI(49115)
	.byte HI(44626)
	.byte HI(56045)
	.byte HI(52068)
	.byte HI(63999)
	.byte HI(59510)
	.byte HI(8450)
	.byte HI(12427)
	.byte HI(528)
	.byte HI(5017)
	.byte HI(26406)
	.byte HI(30383)
	.byte HI(17460)
	.byte HI(21949)
	.byte HI(44362)
	.byte HI(48323)
	.byte HI(36440)
	.byte HI(40913)
	.byte HI(60270)
	.byte HI(64231)
	.byte HI(51324)
	.byte HI(55797)
	.byte HI(12675)
	.byte HI(8202)
	.byte HI(4753)
	.byte HI(792)
	.byte HI(30631)
	.byte HI(26158)
	.byte HI(21685)
	.byte HI(17724)
	.byte HI(48587)
	.byte HI(44098)
	.byte HI(40665)
	.byte HI(36688)
	.byte HI(64495)
	.byte HI(60006)
	.byte HI(55549)
	.byte HI(51572)
	.byte HI(16900)
	.byte HI(21389)
	.byte HI(24854)
	.byte HI(28831)
	.byte HI(1056)
	.byte HI(5545)
	.byte HI(10034)
	.byte HI(14011)
	.byte HI(52812)
	.byte HI(57285)
	.byte HI(60766)
	.byte HI(64727)
	.byte HI(34920)
	.byte HI(39393)
	.byte HI(43898)
	.byte HI(47859)
	.byte HI(21125)
	.byte HI(17164)
	.byte HI(29079)
	.byte HI(24606)
	.byte HI(5281)
	.byte HI(1320)
	.byte HI(14259)
	.byte HI(9786)
	.byte HI(57037)
	.byte HI(53060)
	.byte HI(64991)
	.byte HI(60502)
	.byte HI(39145)
	.byte HI(35168)
	.byte HI(48123)
	.byte HI(43634)
	.byte HI(25350)
	.byte HI(29327)
	.byte HI(16404)
	.byte HI(20893)
	.byte HI(9506)
	.byte HI(13483)
	.byte HI(1584)
	.byte HI(6073)
	.byte HI(61262)
	.byte HI(65223)
	.byte HI(52316)
	.byte HI(56789)
	.byte HI(43370)
	.byte HI(47331)
	.byte HI(35448)
	.byte HI(39921)
	.byte HI(29575)
	.byte HI(25102)
	.byte HI(20629)
	.byte HI(16668)
	.byte HI(13731)
	.byte HI(9258)
	.byte HI(5809)
	.byte HI(1848)
	.byte HI(65487)
	.byte HI(60998)
	.byte HI(56541)
	.byte HI(52564)
	.byte HI(47595)
	.byte HI(43106)
	.byte HI(39673)
	.byte HI(35696)
	.byte HI(33800)
	.byte HI(38273)
	.byte HI(42778)
	.byte HI(46739)
	.byte HI(49708)
	.byte HI(54181)
	.byte HI(57662)
	.byte HI(61623)
	.byte HI(2112)
	.byte HI(6601)
	.byte HI(11090)
	.byte HI(15067)
	.byte HI(20068)
	.byte HI(24557)
	.byte HI(28022)
	.byte HI(31999)
	.byte HI(38025)
	.byte HI(34048)
	.byte HI(47003)
	.byte HI(42514)
	.byte HI(53933)
	.byte HI(49956)
	.byte HI(61887)
	.byte HI(57398)
	.byte HI(6337)
	.byte HI(2376)
	.byte HI(15315)
	.byte HI(10842)
	.byte HI(24293)
	.byte HI(20332)
	.byte HI(32247)
	.byte HI(27774)
	.byte HI(42250)
	.byte HI(46211)
	.byte HI(34328)
	.byte HI(38801)
	.byte HI(58158)
	.byte HI(62119)
	.byte HI(49212)
	.byte HI(53685)
	.byte HI(10562)
	.byte HI(14539)
	.byte HI(2640)
	.byte HI(7129)
	.byte HI(28518)
	.byte HI(32495)
	.byte HI(19572)
	.byte HI(24061)
	.byte HI(46475)
	.byte HI(41986)
	.byte HI(38553)
	.byte HI(34576)
	.byte HI(62383)
	.byte HI(57894)
	.byte HI(53437)
	.byte HI(49460)
	.byte HI(14787)
	.byte HI(10314)
	.byte HI(6865)
	.byte HI(2904)
	.byte HI(32743)
	.byte HI(28270)
	.byte HI(23797)
	.byte HI(19836)
	.byte HI(50700)
	.byte HI(55173)
	.byte HI(58654)
	.byte HI(62615)
	.byte HI(32808)
	.byte HI(37281)
	.byte HI(41786)
	.byte HI(45747)
	.byte HI(19012)
	.byte HI(23501)
	.byte HI(26966)
	.byte HI(30943)
	.byte HI(3168)
	.byte HI(7657)
	.byte HI(12146)
	.byte HI(16123)
	.byte HI(54925)
	.byte HI(50948)
	.byte HI(62879)
	.byte HI(58390)
	.byte HI(37033)
	.byte HI(33056)
	.byte HI(46011)
	.byte HI(41522)
	.byte HI(23237)
	.byte HI(19276)
	.byte HI(31191)
	.byte HI(26718)
	.byte HI(7393)
	.byte HI(3432)
	.byte HI(16371)
	.byte HI(11898)
	.byte HI(59150)
	.byte HI(63111)
	.byte HI(50204)
	.byte HI(54677)
	.byte HI(41258)
	.byte HI(45219)
	.byte HI(33336)
	.byte HI(37809)
	.byte HI(27462)
	.byte HI(31439)
	.byte HI(18516)
	.byte HI(23005)
	.byte HI(11618)
	.byte HI(15595)
	.byte HI(3696)
	.byte HI(8185)
	.byte HI(63375)
	.byte HI(58886)
	.byte HI(54429)
	.byte HI(50452)
	.byte HI(45483)
	.byte HI(40994)
	.byte HI(37561)
	.byte HI(33584)
	.byte HI(31687)
	.byte HI(27214)
	.byte HI(22741)
	.byte HI(18780)
	.byte HI(15843)
	.byte HI(11370)
	.byte HI(7921)
	.byte HI(3960)
crctbl_lo:
	.byte LO( 0)
	.byte LO( 4489)
	.byte LO( 8978)
	.byte LO( 12955)
	.byte LO( 17956)
	.byte LO( 22445)
	.byte LO( 25910)
	.byte LO( 29887)
	.byte LO( 35912)
	.byte LO( 40385)
	.byte LO( 44890)
	.byte LO( 48851)
	.byte LO( 51820)
	.byte LO( 56293)
	.byte LO( 59774)
	.byte LO( 63735)
	.byte LO( 4225)
	.byte LO( 264)
	.byte LO( 13203)
	.byte LO( 8730)
	.byte LO( 22181)
	.byte LO( 18220)
	.byte LO( 30135)
	.byte LO( 25662)
	.byte LO( 40137)
	.byte LO( 36160)
	.byte LO( 49115)
	.byte LO( 44626)
	.byte LO( 56045)
	.byte LO( 52068)
	.byte LO( 63999)
	.byte LO( 59510)
	.byte LO( 8450)
	.byte LO( 12427)
	.byte LO( 528)
	.byte LO( 5017)
	.byte LO( 26406)
	.byte LO( 30383)
	.byte LO( 17460)
	.byte LO( 21949)
	.byte LO( 44362)
	.byte LO( 48323)
	.byte LO( 36440)
	.byte LO( 40913)
	.byte LO( 60270)
	.byte LO( 64231)
	.byte LO( 51324)
	.byte LO( 55797)
	.byte LO( 12675)
	.byte LO( 8202)
	.byte LO( 4753)
	.byte LO( 792)
	.byte LO( 30631)
	.byte LO( 26158)
	.byte LO( 21685)
	.byte LO( 17724)
	.byte LO( 48587)
	.byte LO( 44098)
	.byte LO( 40665)
	.byte LO( 36688)
	.byte LO( 64495)
	.byte LO( 60006)
	.byte LO( 55549)
	.byte LO( 51572)
	.byte LO( 16900)
	.byte LO( 21389)
	.byte LO( 24854)
	.byte LO( 28831)
	.byte LO( 1056)
	.byte LO( 5545)
	.byte LO( 10034)
	.byte LO( 14011)
	.byte LO( 52812)
	.byte LO( 57285)
	.byte LO( 60766)
	.byte LO( 64727)
	.byte LO( 34920)
	.byte LO( 39393)
	.byte LO( 43898)
	.byte LO( 47859)
	.byte LO( 21125)
	.byte LO( 17164)
	.byte LO( 29079)
	.byte LO( 24606)
	.byte LO( 5281)
	.byte LO( 1320)
	.byte LO( 14259)
	.byte LO( 9786)
	.byte LO( 57037)
	.byte LO( 53060)
	.byte LO( 64991)
	.byte LO( 60502)
	.byte LO( 39145)
	.byte LO( 35168)
	.byte LO( 48123)
	.byte LO( 43634)
	.byte LO( 25350)
	.byte LO( 29327)
	.byte LO( 16404)
	.byte LO( 20893)
	.byte LO( 9506)
	.byte LO( 13483)
	.byte LO( 1584)
	.byte LO( 6073)
	.byte LO( 61262)
	.byte LO( 65223)
	.byte LO( 52316)
	.byte LO( 56789)
	.byte LO( 43370)
	.byte LO( 47331)
	.byte LO( 35448)
	.byte LO( 39921)
	.byte LO( 29575)
	.byte LO( 25102)
	.byte LO( 20629)
	.byte LO( 16668)
	.byte LO( 13731)
	.byte LO( 9258)
	.byte LO( 5809)
	.byte LO( 1848)
	.byte LO( 65487)
	.byte LO( 60998)
	.byte LO( 56541)
	.byte LO( 52564)
	.byte LO( 47595)
	.byte LO( 43106)
	.byte LO( 39673)
	.byte LO( 35696)
	.byte LO( 33800)
	.byte LO( 38273)
	.byte LO( 42778)
	.byte LO( 46739)
	.byte LO( 49708)
	.byte LO( 54181)
	.byte LO( 57662)
	.byte LO( 61623)
	.byte LO( 2112)
	.byte LO( 6601)
	.byte LO( 11090)
	.byte LO( 15067)
	.byte LO( 20068)
	.byte LO( 24557)
	.byte LO( 28022)
	.byte LO( 31999)
	.byte LO( 38025)
	.byte LO( 34048)
	.byte LO( 47003)
	.byte LO( 42514)
	.byte LO( 53933)
	.byte LO( 49956)
	.byte LO( 61887)
	.byte LO( 57398)
	.byte LO( 6337)
	.byte LO( 2376)
	.byte LO( 15315)
	.byte LO( 10842)
	.byte LO( 24293)
	.byte LO( 20332)
	.byte LO( 32247)
	.byte LO( 27774)
	.byte LO( 42250)
	.byte LO( 46211)
	.byte LO( 34328)
	.byte LO( 38801)
	.byte LO( 58158)
	.byte LO( 62119)
	.byte LO( 49212)
	.byte LO( 53685)
	.byte LO( 10562)
	.byte LO( 14539)
	.byte LO( 2640)
	.byte LO( 7129)
	.byte LO( 28518)
	.byte LO( 32495)
	.byte LO( 19572)
	.byte LO( 24061)
	.byte LO( 46475)
	.byte LO( 41986)
	.byte LO( 38553)
	.byte LO( 34576)
	.byte LO( 62383)
	.byte LO( 57894)
	.byte LO( 53437)
	.byte LO( 49460)
	.byte LO( 14787)
	.byte LO( 10314)
	.byte LO( 6865)
	.byte LO( 2904)
	.byte LO( 32743)
	.byte LO( 28270)
	.byte LO( 23797)
	.byte LO( 19836)
	.byte LO( 50700)
	.byte LO( 55173)
	.byte LO( 58654)
	.byte LO( 62615)
	.byte LO( 32808)
	.byte LO( 37281)
	.byte LO( 41786)
	.byte LO( 45747)
	.byte LO( 19012)
	.byte LO( 23501)
	.byte LO( 26966)
	.byte LO( 30943)
	.byte LO( 3168)
	.byte LO( 7657)
	.byte LO( 12146)
	.byte LO( 16123)
	.byte LO( 54925)
	.byte LO( 50948)
	.byte LO( 62879)
	.byte LO( 58390)
	.byte LO( 37033)
	.byte LO( 33056)
	.byte LO( 46011)
	.byte LO( 41522)
	.byte LO( 23237)
	.byte LO( 19276)
	.byte LO( 31191)
	.byte LO( 26718)
	.byte LO( 7393)
	.byte LO( 3432)
	.byte LO( 16371)
	.byte LO( 11898)
	.byte LO( 59150)
	.byte LO( 63111)
	.byte LO( 50204)
	.byte LO( 54677)
	.byte LO( 41258)
	.byte LO( 45219)
	.byte LO( 33336)
	.byte LO( 37809)
	.byte LO( 27462)
	.byte LO( 31439)
	.byte LO( 18516)
	.byte LO( 23005)
	.byte LO( 11618)
	.byte LO( 15595)
	.byte LO( 3696)
	.byte LO( 8185)
	.byte LO( 63375)
	.byte LO( 58886)
	.byte LO( 54429)
	.byte LO( 50452)
	.byte LO( 45483)
	.byte LO( 40994)
	.byte LO( 37561)
	.byte LO( 33584)
	.byte LO( 31687)
	.byte LO( 27214)
	.byte LO( 22741)
	.byte LO( 18780)
	.byte LO( 15843)
	.byte LO( 11370)
	.byte LO( 7921)
	.byte LO( 3960)

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Convention: Caps in main menu.
!
!  toplevel records hold a pointer to the 1st and to the last (yes, not +1)
!  record on the sublevel. ptr tells where the variable itself lives.
!  arg is misc address. default is encoded into the last 3 free bytes.
!----------------------------------------------------------------------
offset_type = 0
offset_arg  = 1
offset_ptr  = 3
offset_title = 5
offset_default = 5 + 8

#define CFG_REC(tit,ptr,typ,arg) \
  .byte typ; .word arg, ptr; .ascii tit; .byte /* 3 more bytes */
#define CFG_PAD 0,0,0

#define CFG_TOP(tit,ptr) CFG_REC(tit, ptr, CFG_NOTYPE, end_/**/ptr -16) CFG_PAD

#define CFG_SEL(str) _: .ascii str; .align 3, 0
#define CFG_SEL_END .byte 0; .align 4, 0xFF

#define PACK_FREQ(f) LO(f), HI(f), LO(f/65536)

.align 4, 0xFF
!!----------------------------------------------------------------------
!! SETUP
!!----------------------------------------------------------------------
!! RESERVED
!! No functionality.
!!----------------------------------------------------------------------
menu_reserved:
	CFG_REC("XXX    0", cfg_XXX_0, CFG_BYTE, 0) CFG_PAD
	CFG_REC("XXX    1", cfg_XXX_1, CFG_BYTE, 0) CFG_PAD
	CFG_REC("XXX    2", cfg_XXX_2, CFG_BYTE, 0) CFG_PAD
	CFG_REC("XXX    3", cfg_XXX_3, CFG_BYTE, 0) CFG_PAD
end_menu_reserved:
!!----------------------------------------------------------------------
!! HOTLIST
!! Often used things (?)
!! DTMF, CCIR, CTCSS and RGR BEEP index into series in TX TONES.
!!----------------------------------------------------------------------
menu_hotlist:
	CFG_REC("TX Power", cfg_txpwr,     CFG_PERCENT, 0) 50, 0,0
	CFG_REC("DTMF    ", cfg_dtmf_idx,  CFG_TAB, 1f) CFG_PAD
	CFG_REC("CCIR    ", cfg_ccir_idx,  CFG_TAB, 1f) CFG_PAD
	CFG_REC("CTCSS   ", cfg_ctcss_idx, CFG_TAB, 1f) CFG_PAD
	CFG_REC("RGR BEEP", cfg_roger_idx, CFG_TAB, 1f) CFG_PAD
end_menu_hotlist:
1:
	CFG_SEL("OFF")
	CFG_SEL("SEQ 1")
	CFG_SEL("SEQ 2")
	CFG_SEL("SEQ 3")
	CFG_SEL("SEQ 4")
	CFG_SEL("SEQ 5")
	CFG_SEL("SEQ 6")
	CFG_SEL("SEQ 7")
	CFG_SEL("SEQ 8")
	CFG_SEL_END
!!----------------------------------------------------------------------
!! BAND CFG
!! CallFreq and MostUsed are quickly selectable with successive OKs.
!! RX   Low/High XXX Seems this has no reason to be here at all.
!! TX   Low/High limits the legal tranmit area.
!! Rptr Low/High limit an area which automatically selects duplex
!!              (duplex is cleared outside this area outside memories).
!! Implied gives the missing digits for shorter frequency entry.
!! Ch Step affects NEXT/PREV buttons and scanner.
!!----------------------------------------------------------------------
menu_bands:
	CFG_REC("CallFreq", cfg_callfreq,       CFG_FREQ, 0) PACK_FREQ(433500)
	CFG_REC("MostUsed", cfg_my_favorite,    CFG_FREQ, 0) PACK_FREQ(433500)
	CFG_REC("RX Low  ", cfg_rxband_low,     CFG_FREQ, 0) PACK_FREQ(432000)
	CFG_REC("RX High ", cfg_rxband_high,    CFG_FREQ, 0) PACK_FREQ(438000)
	CFG_REC("TX Low  ", cfg_txband_low,     CFG_FREQ, 0) PACK_FREQ(432000)
	CFG_REC("TX High ", cfg_txband_high,    CFG_FREQ, 0) PACK_FREQ(438000)
	CFG_REC("Rptr Low", cfg_rptr_area_low,  CFG_FREQ, 0) PACK_FREQ(434600)
	CFG_REC("Rptr Hi ", cfg_rptr_area_high, CFG_FREQ, 0) PACK_FREQ(435000)
	CFG_REC("Implied ", cfg_freq_implied,   CFG_FREQ, 0) PACK_FREQ(433000)
	CFG_REC("Ch Step ", cfg_chan_step,      CFG_TAB, 1f) 0, 0,0
end_menu_bands:
1:
	CFG_SEL("25")
	CFG_SEL("20")
	CFG_SEL("12")
	CFG_SEL("10")
	CFG_SEL_END
	
!!----------------------------------------------------------------------
!! CHARGER 
!! Battery charger control OH3NWQ
!! 
!! 
!!----------------------------------------------------------------------
menu_charger:
	CFG_REC("Charger ", cfg_charger_cycle,      CFG_TAB, 1f) CFG_PAD
	CFG_REC("Method  ", cfg_charger_method,     CFG_TAB, 2f) CFG_PAD
	CFG_REC("Ch end V", cfg_charger_v_end,      CFG_BYTE, 0) 150, 0,0
	CFG_REC("Ch res V", cfg_charger_v_resume,   CFG_BYTE, 0) 100, 0,0
	CFG_REC("Ch end T", cfg_charger_t_end,      CFG_BYTE, 0) 200, 0,0
	CFG_REC("Ch res T", cfg_charger_t_resume,   CFG_BYTE, 0) 150, 0,0
end_menu_charger:
1:
	CFG_SEL("Off")
	CFG_SEL("Trickle")
	CFG_SEL("Cycle")
	CFG_SEL_END
2:	
	CFG_SEL("Pulse")
	CFG_SEL("Fast")
	CFG_SEL_END

!!----------------------------------------------------------------------
!! DUPLEX
!! Offset and Transmit Side are in effect outside of memories.
!! Also these are saved in memories at the moment the memory is stored.
!! Lazy Beep gives a short tone of 1750 Hz in the start of the
!! transmission iff duplex is on and the squelch is closed.
!!----------------------------------------------------------------------
menu_duplex:
	CFG_REC("Offset  ", cfg_duplex_off, CFG_FOFF, 0) PACK_FREQ(1600)
	CFG_REC("TX Side ", cfg_duplex_dir, CFG_TAB, 1f) CFG_PAD
	CFG_REC("LazyBeep", cfg_lazy_beep,  CFG_TAB, 2f) CFG_PAD
end_menu_duplex:
1:
	CFG_SEL("BELOW")
	CFG_SEL("ABOVE")
	CFG_SEL_END
2:
	CFG_SEL("OFF")
	CFG_SEL("ON")
	CFG_SEL_END
!!----------------------------------------------------------------------
!! SECURITY (PARENTAL)
!! Few levels of guard against misuse.
!!----------------------------------------------------------------------
menu_parental:
	CFG_REC("LockType", cfg_pin_type, CFG_TAB, 1f) CFG_PAD
	CFG_REC("LockCode", cfg_pin_code, CFG_STRING, SIZE(cfg_pin_code)) CFG_PAD
end_menu_parental:
1:
	CFG_SEL("NONE")
	CFG_SEL("TX")
	CFG_SEL("KEYS")
	CFG_SEL("FULL")
	CFG_SEL_END
!!----------------------------------------------------------------------
!! MISC CFG
!! Mic parameters XXX
!! On- and Off-hook index into SCRIPTS. They allow automatic execution
!! of anything when the handset is replaced to or removed from the cradle.
!! CW parameters XXX
!! MyCall XXX
!! MBUS Id XXX
!! TX Delay XXX "relay speed" from /CRM to +12T and vice versa
!!----------------------------------------------------------------------
menu_misc:
	CFG_REC("Mic Gain", cfg_mic_gain,    CFG_DIGIT, 0) 5, 0,0
	CFG_REC("Mic Src ", cfg_mic_src,     CFG_TAB, 1f)  CFG_PAD
	CFG_REC("On Hook ", cfg_onhook_act,  CFG_TAB, 2f)  CFG_PAD
	CFG_REC("Off Hook", cfg_offhook_act, CFG_TAB, 2f)  CFG_PAD
	CFG_REC("CW Speed", cfg_cw_speed,    CFG_WORD,   0) 120, 0,0
	CFG_REC("CW Pitch", cfg_cw_pitch,    CFG_WORD,   0) 800, 0,0
	CFG_REC("My Call ", cfg_mycall,      CFG_STRING, SIZE(cfg_mycall)) CFG_PAD
	CFG_REC("MBUS Id ", cfg_my_mbusid,   CFG_STRING, SIZE(cfg_my_mbusid)) CFG_PAD
	CFG_REC("TX Delay", cfg_tx_delay,    CFG_MSEC,   0) 0, 0,0
end_menu_misc:
1:
	CFG_SEL("MIC")
	CFG_SEL("HFMIC")
	CFG_SEL("EXTM")
	CFG_SEL_END
2:
	CFG_SEL("NONE")
	CFG_SEL("SCR 1")
	CFG_SEL("SCR 2")
	CFG_SEL("SCR 3")
	CFG_SEL("SCR 4")
	CFG_SEL("SCR 5")
	CFG_SEL("SCR 6")
	CFG_SEL("SCR 7")
	CFG_SEL("SCR 8")
	CFG_SEL("SCR 9")
	CFG_SEL_END
!!----------------------------------------------------------------------
!! VOLUMES
!! LFU Vol. presets the audio level from the radio part. Normal
!! volume adjustment with +/- is done in the handset.
!! Keyclick XXX
!! Alert XXX
!!----------------------------------------------------------------------
menu_volumes:
	CFG_REC("Keyclick", cfg_keyclick, CFG_DIGIT, 0) 1,0,0
	CFG_REC("Alert   ", cfg_alertvol, CFG_DIGIT, 0) CFG_PAD
	CFG_REC("LFU Vol.", cfg_lfu_vol,  CFG_DIGIT, 0) 1, 0,0
end_menu_volumes:
!!----------------------------------------------------------------------
!! TX TONES
!! Stores a number of preset ready-to-use tone series (CCIR/DTMF)
!! or tone frequencies (CTCSS),
!! used thru indexes in HOTLIST.
!! CTCSS frequencies are below 254 Hz, but you can put any Hz here
!! for testing/measurement purposes (like, 1750). 0 = silence. hmm...
!!----------------------------------------------------------------------
menu_txtones:
	CFG_REC("Serie  1", cfg_txtone1, CFG_STRING, SIZE(cfg_txtone1)) CFG_PAD
	CFG_REC("Serie  2", cfg_txtone2, CFG_STRING, SIZE(cfg_txtone2)) CFG_PAD
	CFG_REC("Serie  3", cfg_txtone3, CFG_STRING, SIZE(cfg_txtone3)) CFG_PAD
	CFG_REC("Serie  4", cfg_txtone4, CFG_STRING, SIZE(cfg_txtone4)) CFG_PAD
	CFG_REC("Serie  5", cfg_txtone5, CFG_STRING, SIZE(cfg_txtone5)) CFG_PAD
	CFG_REC("Serie  6", cfg_txtone6, CFG_STRING, SIZE(cfg_txtone6)) CFG_PAD
	CFG_REC("Serie  7", cfg_txtone7, CFG_STRING, SIZE(cfg_txtone7)) CFG_PAD
	CFG_REC("Serie  8", cfg_txtone8, CFG_STRING, SIZE(cfg_txtone8)) CFG_PAD
end_menu_txtones:
!!----------------------------------------------------------------------
!! STATUS
!! A/D and AFC readouts. read-only. Also some debugging help.
!! The scale of Center-display is not Hz. more like 14 or 15 Hz. XXX
!!----------------------------------------------------------------------
menu_status:
	CFG_REC("RSSI    ", 0, CFG_DYN, read_RSSI) CFG_PAD
hack_for_center:
	CFG_REC("Center  ", 0, CFG_DYN,  read_afc)  CFG_PAD
	CFG_REC("TX Power", 0, CFG_DYN,  read_PFB)  CFG_PAD
	CFG_REC("BattVolt", 0, CFG_DYN,  read_BATT) CFG_PAD
	CFG_REC("BattCurr", 0, CFG_DYN,  read_BCR)  CFG_PAD
	CFG_REC("BattTemp", 0, CFG_DYN,  read_BTMP) CFG_PAD
	CFG_REC("Temperat", 0, CFG_DYN,  read_TEMP) CFG_PAD
	CFG_REC("FSKL    ", 0, CFG_DYN,  read_FSKL) CFG_PAD
	CFG_REC("A/D 7   ", 0, CFG_DYN,  read_LOCK) CFG_PAD

	CFG_REC("rxdiv   ", rx_div + 0, CFG_FREQ, 0) CFG_PAD
	CFG_REC("rxref   ", rx_div + 3, CFG_FREQ, 0) CFG_PAD
	CFG_REC("txdiv   ", tx_div + 0, CFG_FREQ, 0) CFG_PAD
	CFG_REC("txref   ", tx_div + 3, CFG_FREQ, 0) CFG_PAD

	CFG_REC("MAS Data", 0, CFG_DYN, read_masd) CFG_PAD
	CFG_REC("MAS Stat", 0, CFG_DYN, read_mass) CFG_PAD
end_menu_status:
!!----------------------------------------------------------------------
!! DEFAULTS
!! DISASTER  clears all ram in radio. Used when taking radio into ham use.
!! RST Some  sets defaults for most parameters. After sw upgrade.
!! RST Mems  wipes out memories. Parameters are unaffected.
!! AFC Ctrl  VCTCXO adjusment. 50% recommended.
!! Deviatio  Deviation control. Experiment.
!! 1st I/F   Keep the default.
!! Inj.Side  Likewise.
!! Dolby     Select compander method (only one (on/off) is supported :).
!!----------------------------------------------------------------------
menu_defaults:
	CFG_REC("RST Some", 0, CFG_RST, cfg_rst_some) CFG_PAD
	CFG_REC("RST Mems", 0, CFG_RST, cfg_rst_mems) CFG_PAD
	CFG_REC("DISASTER", 0, CFG_RST, cfg_suicide)  CFG_PAD
	CFG_REC("AFC Ctrl", cfg_afc_ctrl, CFG_PERCENT, 0) 50, 0,0
	CFG_REC("Deviatio", cfg_deviation,CFG_PERCENT, 0) 50, 0,0
	CFG_REC("1st I/F ", cfg_if_freq,  CFG_FREQ, 0) PACK_FREQ(21400)
	CFG_REC("Inj.Side", cfg_if_dir,   CFG_TAB, 1f) 0, 0,0
	CFG_REC("Dolby   ", cfg_dolby,    CFG_TAB, 2f) 0, 0,0
end_menu_defaults:
1:
	CFG_SEL("ABOVE")
	CFG_SEL("BELOW")
	CFG_SEL_END
2:
	CFG_SEL("OFF")
	CFG_SEL("DBX")
	CFG_SEL("Surround")
	CFG_SEL_END
!!----------------------------------------------------------------------
!! SQUELCH
!! SQ Level  Average of opening- and closing levels.
!! SQ Hyst.  The separation between above levels.
!! SQ Delay  Slowness of squelch to open
!! SQ Tail   Slowness of squelch to close
!!----------------------------------------------------------------------
menu_squelch:
	CFG_REC("SQ Level", cfg_sqlevel, CFG_PERCENT, 0) 25, 0,0
	CFG_REC("SQ Hyst.", cfg_sqhyst,  CFG_PERCENT, 0) 2, 0,0
	CFG_REC("SQ Delay", cfg_sqdelay, CFG_MSEC, 0) 100, 0,0
	CFG_REC("SQ Tail ", cfg_sqtail,  CFG_MSEC, 0) 100, 0,0
end_menu_squelch:
!!----------------------------------------------------------------------
!! SCANNER
!! Sc Wait     seconds before restarting scanning from loss of signal.
!! Sc Listen   seconds before restarting scanning during a long over.
!! Sc Pers.    minutes before restarting scanning in any case.
!! UnReject    minutes before temporarily rejected channel is scanned again.
!! StepRate    time for receiver to wake from frequency change
!! Sc Low/High limit an area to scan, with modes 1 and 2.
!! Sc3 Fq      few spot-frequencies to scan with mode 3
!! AutoScan    scanning starts automatically with the last mode after
!!             no activity either from receiver or from operator.
!!----------------------------------------------------------------------
menu_scanner:
	CFG_REC("Sc1  Low", cfg_sc1_low,       CFG_FREQ, 0) PACK_FREQ(433400)
	CFG_REC("Sc1 High", cfg_sc1_high,      CFG_FREQ, 0) PACK_FREQ(433600)
	CFG_REC("Sc2  Low", cfg_sc2_low,       CFG_FREQ, 0) PACK_FREQ(434600)
	CFG_REC("Sc2 High", cfg_sc2_high,      CFG_FREQ, 0) PACK_FREQ(435000)
	CFG_REC("Sc3 Fq 0", cfg_sc3_freq_0,    CFG_FREQ, 0) PACK_FREQ(433500)
	CFG_REC("Sc3 Fq 1", cfg_sc3_freq_1,    CFG_FREQ, 0) PACK_FREQ(433525)
	CFG_REC("Sc3 Fq 2", cfg_sc3_freq_2,    CFG_FREQ, 0) PACK_FREQ(433550)
	CFG_REC("Sc3 Fq 3", cfg_sc3_freq_3,    CFG_FREQ, 0) PACK_FREQ(433575)
	CFG_REC("Sc Wait ", cfg_scan_wait,     CFG_SEC,    0)  5, 0,0
	CFG_REC("ScListen", cfg_scan_listen,   CFG_SEC,    0) 30, 0,0
	CFG_REC("Sc Pers.", cfg_scan_pers,     CFG_MINUTE, 0)  5, 0,0
	CFG_REC("UnReject", cfg_scan_unreject, CFG_MINUTE, 0) 30, 0,0
	CFG_REC("AutoScan", cfg_autoscan_time, CFG_MINUTE, 0)  0, 0,0
	CFG_REC("StepRate", cfg_step_rate,     CFG_MSEC,   0) 30, 0,0
end_menu_scanner:
!!----------------------------------------------------------------------
!! WARNINGS
!! A limit for stuck transmission.
!! Low voltage and overtemperature limits.
!!----------------------------------------------------------------------
menu_warnings:
	CFG_REC("TX Timer", cfg_tx_timer,  CFG_MINUTE,  0) 10, 0,0
	CFG_REC("Low Volt", cfg_volt_warn, CFG_BYTE,    0) 55, 0,0
	CFG_REC("OverTemp", cfg_temp_warn, CFG_PERCENT, 0) 70, 0,0
end_menu_warnings:
!!----------------------------------------------------------------------
!! REJECTS
!! Few frequencies weeded out from scan ranges 1 and 2. These
!! are permanent.
!!----------------------------------------------------------------------
menu_rejects:
	CFG_REC("Reject 0", cfg_reject_0, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 1", cfg_reject_1, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 2", cfg_reject_2, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 3", cfg_reject_3, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 4", cfg_reject_4, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 5", cfg_reject_5, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 6", cfg_reject_6, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 7", cfg_reject_7, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 8", cfg_reject_8, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 9", cfg_reject_9, CFG_FREQ, 0) PACK_FREQ(0)
end_menu_rejects:
!!----------------------------------------------------------------------
!! SCRIPTS
!! Commands executed after certain events happen.
!!----------------------------------------------------------------------
menu_scripts:
	CFG_REC("Script 1", cfg_script_1, CFG_STRING, SIZE(cfg_script_1)) CFG_PAD
	CFG_REC("Script 2", cfg_script_2, CFG_STRING, SIZE(cfg_script_2)) CFG_PAD
	CFG_REC("Script 3", cfg_script_3, CFG_STRING, SIZE(cfg_script_3)) CFG_PAD
	CFG_REC("Script 4", cfg_script_4, CFG_STRING, SIZE(cfg_script_4)) CFG_PAD
	CFG_REC("Script 5", cfg_script_5, CFG_STRING, SIZE(cfg_script_5)) CFG_PAD
	CFG_REC("Script 6", cfg_script_6, CFG_STRING, SIZE(cfg_script_6)) CFG_PAD
	CFG_REC("Script 7", cfg_script_7, CFG_STRING, SIZE(cfg_script_7)) CFG_PAD
	CFG_REC("Script 8", cfg_script_8, CFG_STRING, SIZE(cfg_script_8)) CFG_PAD
	CFG_REC("Script 9", cfg_script_9, CFG_STRING, SIZE(cfg_script_9)) CFG_PAD
	CFG_REC("Script 0", cfg_script_0, CFG_STRING, SIZE(cfg_script_0)) CFG_PAD
end_menu_scripts:
!!----------------------------------------------------------------------
!! PUTES
!!----------------------------------------------------------------------
menu_main:
	CFG_TOP("HOTLIST ",menu_hotlist)
	CFG_TOP("SQUELCH ",menu_squelch)
	CFG_TOP("VOLUMES ",menu_volumes)
	CFG_TOP("SCANNER ",menu_scanner)
	CFG_TOP("REJECTS ",menu_rejects)
	CFG_TOP("MISC CFG",menu_misc)
	CFG_TOP("BAND CFG",menu_bands)
	CFG_TOP("DUPLEX  ",menu_duplex)
	CFG_TOP("SCRIPTS ",menu_scripts)
	CFG_TOP("TX TONES",menu_txtones)
	CFG_TOP("WARNINGS",menu_warnings)
	CFG_TOP("CHARGER ",menu_charger)
	CFG_TOP("SECURITY",menu_parental)
	CFG_TOP("DEFAULTS",menu_defaults)
	CFG_TOP("RESERVED",menu_reserved)
	CFG_TOP("STATUS  ",menu_status)
end_menu_main:
!----------------------------------------------------------------------
!
!  indirect frequencies from here for default values.
!	                 70cm                23cm
!frequencies_for_bands:
!	.byte PACK_FREQ(     0), PACK_FREQ(      0) !  0 nofreq
!	.byte PACK_FREQ(433500), PACK_FREQ(1297500) !  1 callfreq
!	.byte PACK_FREQ(433500), PACK_FREQ(1297500) !  2 mostused
!	.byte PACK_FREQ(432000), PACK_FREQ(1240000) !  3 rx low
!	.byte PACK_FREQ(438000), PACK_FREQ(1300000) !  4 rx high
!	.byte PACK_FREQ(432000), PACK_FREQ(1240000) !  5 tx low
!	.byte PACK_FREQ(438000), PACK_FREQ(1300000) !  6 tx high
!	.byte PACK_FREQ(434600), PACK_FREQ(1297000) !  7 rptr low
!	.byte PACK_FREQ(435000), PACK_FREQ(1297475) !  8 rptr high
!	.byte PACK_FREQ(433000), PACK_FREQ(1297000) !  9 implied
!	.byte PACK_FREQ(  1600), PACK_FREQ(   6000) ! 10 duplex offset
!	.byte PACK_FREQ( 21400), PACK_FREQ(  86513) ! 11 1st IF
!	.byte PACK_FREQ(433400), PACK_FREQ(1297500) ! 12 sc1 low
!	.byte PACK_FREQ(433600), PACK_FREQ(1298000) ! 13 sc1 high
!	.byte PACK_FREQ(434600), PACK_FREQ(1297000) ! 14 sc2 low
!	.byte PACK_FREQ(435000), PACK_FREQ(1297475) ! 15 sc2 high
!	.byte PACK_FREQ(433500), PACK_FREQ(1297500) ! 16 sc3 fq1
!	.byte PACK_FREQ(433525), PACK_FREQ(1297525) ! 17 sc3 fq2
!	.byte PACK_FREQ(433550), PACK_FREQ(1297550) ! 18 sc3 fq3
!	.byte PACK_FREQ(433575), PACK_FREQ(1297575) ! 19 sc3 fq4

!----------------------------------------------------------------------
!----------------------------------------------------------------------

	.ascii "\n\n\n\n@(#)"
version:
	.ascii VERSION_1, "  ", VERSION_2
	.byte 0

TheEnd:

